/*
Sfmt.cs Cu ȈՔ
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int index;
    uint[]x=new uint[624]; /* ԃe[u */

    void gen_rand_all() {
        int a=0,b=488,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>11)&0xbffffff6U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>11)&0xbffaffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>11)&0xddfecb7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>11)&0xdfffffefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    void period_certification() {
        uint work,inner=0; int i,j;
        uint[] parity={ 0x00000001U,0x00000000U,0x00000000U,0x13c9e684U };

        index=624;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<624;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==624) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

}
