/*
Sfmt11213.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[352]; /* ԃe[u */

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xe8148000U,0xd0c7afa3U };

    protected virtual uint[]GetParity() { return ParityData; }

    public virtual string IdString { get {
        return"SFMT-11213:68-14-3-7-3:effff7fb-ffffffef-dfdfbfff-7fffdbfd";
    } }

    public virtual void gen_rand_all() {
        int a=0,b=272,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>7)&0x7fffdbfdU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>7)&0xdfdfbfffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>7)&0xffffffefU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>7)&0xeffff7fbU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=352; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<352;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<352;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>352) c=key_len+1; else c=352;
            r=x[0]^x[172]^x[351]; r=(r^(r>>27))*1664525;
            x[172]+=r; r+=key_len; x[179]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+172)%352]^x[(i+351)%352];
                r=(r^(r>>27))*1664525; x[(i+172)%352]+=r;
                r+=init_key[j]+i; x[(i+179)%352]+=r;
                x[i]=r; i=(i+1)%352;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+172)%352]^x[(i+351)%352];
                r=(r^(r>>27))*1664525; x[(i+172)%352]+=r; r+=i;
                x[(i+179)%352]+=r; x[i]=r; i=(i+1)%352;
            }
            for (j=0;j<352;j++) {
                r=x[i]+x[(i+172)%352]+x[(i+351)%352];
                r=(r^(r>>27))*1566083941; x[(i+172)%352]^=r;
                r-=i; x[(i+179)%352]^=r; x[i]=r; i=(i+1)%352;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==352) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt1 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:73-11-3-2-5:ff6ffcff-bff77dff-77dfffff-fbfffffb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xbcaaa000U,0x278c70beU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=292,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>2)&0xfbfffffbU);
            p[a+3]=y^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>2)&0x77dfffffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>2)&0xbff77dffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>2)&0xff6ffcffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt1(uint s) : base(s) { }
    public Sfmt1(uint[]init_key) : base(init_key) { }
}

class Sfmt2 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:72-13-3-1-1:7ff7ffff-afffcdde-effffeff-ffffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x03dc0000U,0x1f9394f8U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=288,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>1)&0xffffffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>1)&0xeffffeffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>1)&0xafffcddeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>1)&0x7ff7ffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt2(uint s) : base(s) { }
    public Sfmt2(uint[]init_key) : base(init_key) { }
}

class Sfmt3 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:63-22-1-13-1:f5fbfffb-ffffffbf-df7ffcb7-dffff7ff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xf73ca000U,0x2ad648b9U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=252,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>13)&0xdffff7ffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>13)&0xdf7ffcb7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>13)&0xffffffbfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>13)&0xf5fbfffbU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt3(uint s) : base(s) { }
    public Sfmt3(uint[]init_key) : base(init_key) { }
}

class Sfmt4 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:73-12-3-9-1:ddffdff7-6baffff7-7bd5ffff-efd3fbff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xf75e8000U,0xb53672e0U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=292,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>9)&0xefd3fbffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>9)&0x7bd5ffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>9)&0x6baffff7U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<24)^((p[b]>>9)&0xddffdff7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt4(uint s) : base(s) { }
    public Sfmt4(uint[]init_key) : base(init_key) { }
}

class Sfmt5 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:48-10-3-9-5:5dffefcd-c6ffffdf-fe77bfff-ffefefff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x6f4ea000U,0x1b8db4baU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=192,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>9)&0xffefefffU);
            p[a+3]=y^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>9)&0xfe77bfffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>9)&0xc6ffffdfU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>9)&0x5dffefcdU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt5(uint s) : base(s) { }
    public Sfmt5(uint[]init_key) : base(init_key) { }
}

class Sfmt6 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:45-13-3-10-5:fbffd7ff-ddf7f7e7-9bffe71f-ff7ec3ff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x830e0000U,0xcd4127afU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=180,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>10)&0xff7ec3ffU);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>10)&0x9bffe71fU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>10)&0xddf7f7e7U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>10)&0xfbffd7ffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt6(uint s) : base(s) { }
    public Sfmt6(uint[]init_key) : base(init_key) { }
}

class Sfmt7 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:58-7-7-5-1:7defffff-7d9bffff-fdbff7ee-dfffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x5b202000U,0x95b190fdU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=232,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>5)&0xdfffffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>5)&0xfdbff7eeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>5)&0x7d9bffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^((p[b]>>5)&0x7defffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt7(uint s) : base(s) { }
    public Sfmt7(uint[]init_key) : base(init_key) { }
}

class Sfmt8 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:86-19-1-5-1:fffffebf-fdeffadf-7fb71fcf-ffff5fff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x953e8000U,0xf7bd34c4U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=344,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xffff5fffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0x7fb71fcfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0xfdeffadfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0xfffffebfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt8(uint s) : base(s) { }
    public Sfmt8(uint[]init_key) : base(init_key) { }
}

class Sfmt9 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:84-22-1-7-1:fff7effe-bfb7afff-b7dfffff-bf7f7fef";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xe1d70000U,0x02717d9dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=336,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>7)&0xbf7f7fefU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>7)&0xb7dfffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>7)&0xbfb7afffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>7)&0xfff7effeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt9(uint s) : base(s) { }
    public Sfmt9(uint[]init_key) : base(init_key) { }
}

class Sfmt10 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:33-6-7-7-1:fffff9ff-fb7fffff-ebeffdfe-fbfbffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x8a3d0800U,0x026e932dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=132,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>7)&0xfbfbffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>7)&0xebeffdfeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>7)&0xfb7fffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^((p[b]>>7)&0xfffff9ffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt10(uint s) : base(s) { }
    public Sfmt10(uint[]init_key) : base(init_key) { }
}

class Sfmt11 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:22-14-7-7-1:fffefbf7-effffb7e-fefdfbbf-e7ffffdf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x5c142000U,0x0aaefe70U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=88,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>7)&0xe7ffffdfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>7)&0xfefdfbbfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>7)&0xeffffb7eU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^((p[b]>>7)&0xfffefbf7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt11(uint s) : base(s) { }
    public Sfmt11(uint[]init_key) : base(init_key) { }
}

class Sfmt12 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:79-22-1-17-1:ffbf7ff7-9dffdfdf-dfef97bf-dfeebf7f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x68cbe000U,0x1c20bdd1U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=316,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>17)&0xdfeebf7fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>17)&0xdfef97bfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>17)&0x9dffdfdfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>17)&0xffbf7ff7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt12(uint s) : base(s) { }
    public Sfmt12(uint[]init_key) : base(init_key) { }
}

class Sfmt13 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:77-9-3-10-3:fffffffe-3feefbff-f7fefeff-f5bc9fff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x73b20000U,0xb134ef9cU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=308,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>10)&0xf5bc9fffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>10)&0xf7fefeffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>10)&0x3feefbffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>10)&0xfffffffeU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt13(uint s) : base(s) { }
    public Sfmt13(uint[]init_key) : base(init_key) { }
}

class Sfmt14 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:45-17-1-6-3:f77bbfef-bcf7bfdf-bffff7e7-fffaff7b";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xce408000U,0x1344dad1U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=180,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>6)&0xfffaff7bU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>6)&0xbffff7e7U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>6)&0xbcf7bfdfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<8)^((p[b]>>6)&0xf77bbfefU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt14(uint s) : base(s) { }
    public Sfmt14(uint[]init_key) : base(init_key) { }
}

class Sfmt15 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:41-13-1-4-3:fb5d7fff-fbff7bff-f7ff677f-c67fffbf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x0eb18000U,0xafe068e2U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=164,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>4)&0xc67fffbfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>4)&0xf7ff677fU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>4)&0xfbff7bffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>4)&0xfb5d7fffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt15(uint s) : base(s) { }
    public Sfmt15(uint[]init_key) : base(init_key) { }
}

class Sfmt16 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:69-6-3-3-1:effdfdff-f9bffbff-dff1ffff-f7f8dfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x83409000U,0xc4651bf2U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=276,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xf7f8dfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xdff1ffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xf9bffbffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xeffdfdffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt16(uint s) : base(s) { }
    public Sfmt16(uint[]init_key) : base(init_key) { }
}

class Sfmt17 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:48-12-3-17-1:de5fffbf-f7d5f7be-fff7757d-fffeef79";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xa25c0200U,0xa9cb6a61U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=192,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>17)&0xfffeef79U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>17)&0xfff7757dU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>17)&0xf7d5f7beU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<24)^((p[b]>>17)&0xde5fffbfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt17(uint s) : base(s) { }
    public Sfmt17(uint[]init_key) : base(init_key) { }
}

class Sfmt18 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:9-18-5-15-1:5fe7eff7-dbffdff3-dbff6ff7-bb377fff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xa0b64800U,0xc3969fa3U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=36,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>15)&0xbb377fffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>15)&0xdbff6ff7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>15)&0xdbffdff3U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^((p[b]>>15)&0x5fe7eff7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt18(uint s) : base(s) { }
    public Sfmt18(uint[]init_key) : base(init_key) { }
}

class Sfmt19 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:48-11-7-17-1:ffd7ebff-efffff7b-efbfffbd-f7f7efae";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x76adc000U,0xdd5c6c66U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=192,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>17)&0xf7f7efaeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>17)&0xefbfffbdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>17)&0xefffff7bU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^((p[b]>>17)&0xffd7ebffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt19(uint s) : base(s) { }
    public Sfmt19(uint[]init_key) : base(init_key) { }
}

class Sfmt20 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:36-5-7-17-1:ccfe7ffe-fadfffff-fffffdff-ffefefff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x637cd000U,0xedd65806U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=144,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>17)&0xffefefffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>17)&0xfffffdffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>17)&0xfadfffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^((p[b]>>17)&0xccfe7ffeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt20(uint s) : base(s) { }
    public Sfmt20(uint[]init_key) : base(init_key) { }
}

class Sfmt21 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:12-7-3-11-1:fffbe5fb-fdfdf7df-fffdf7ff-fffffffb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x43f60800U,0x4f337b1dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=48,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xfffffffbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xfffdf7ffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xfdfdf7dfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xfffbe5fbU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt21(uint s) : base(s) { }
    public Sfmt21(uint[]init_key) : base(init_key) { }
}

class Sfmt22 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:37-21-3-4-5:76fe7fff-79ffffff-7ff7dfff-bbfbefff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x2aa69000U,0xa1bd24ddU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=148,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>4)&0xbbfbefffU);
            p[a+3]=y^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>4)&0x7ff7dfffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>4)&0x79ffffffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>4)&0x76fe7fffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt22(uint s) : base(s) { }
    public Sfmt22(uint[]init_key) : base(init_key) { }
}

class Sfmt23 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:85-19-7-10-1:fffdfbff-ffbffa3f-ffbffa2f-ffdfffbf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xfe0c8800U,0xceed51f4U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=340,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>10)&0xffdfffbfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>10)&0xffbffa2fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>10)&0xffbffa3fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^((p[b]>>10)&0xfffdfbffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt23(uint s) : base(s) { }
    public Sfmt23(uint[]init_key) : base(init_key) { }
}

class Sfmt24 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:42-13-7-21-1:ff3ebfbe-ff7fffde-5ffffbef-fffefbfb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x0443a000U,0x35321b2aU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=168,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>21)&0xfffefbfbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>21)&0x5ffffbefU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>21)&0xff7fffdeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^((p[b]>>21)&0xff3ebfbeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt24(uint s) : base(s) { }
    public Sfmt24(uint[]init_key) : base(init_key) { }
}

class Sfmt25 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:38-16-3-1-5:fdf7dbff-fbffdffb-fbffbfd9-fffffdbd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x16d92000U,0xacd93bf9U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=152,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>1)&0xfffffdbdU);
            p[a+3]=y^(p[d+3]<<16);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>1)&0xfbffbfd9U);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<16);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>1)&0xfbffdffbU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<16);
            y=p[a]^(p[a]<<24)^((p[b]>>1)&0xfdf7dbffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<16);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt25(uint s) : base(s) { }
    public Sfmt25(uint[]init_key) : base(init_key) { }
}

class Sfmt26 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:80-3-3-1-3:f77efedf-f7fffbeb-cbffffe7-fdfffbff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xbca5a000U,0x45e06438U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=320,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>1)&0xfdfffbffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>1)&0xcbffffe7U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>1)&0xf7fffbebU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>1)&0xf77efedfU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt26(uint s) : base(s) { }
    public Sfmt26(uint[]init_key) : base(init_key) { }
}

class Sfmt27 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:37-21-7-6-1:ffcffdff-fedffdff-fcbffffb-ffeffebf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xf8270000U,0xf6fdf776U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=148,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>6)&0xffeffebfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>6)&0xfcbffffbU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>6)&0xfedffdffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^((p[b]>>6)&0xffcffdffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt27(uint s) : base(s) { }
    public Sfmt27(uint[]init_key) : base(init_key) { }
}

class Sfmt28 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:14-11-1-21-1:ffffffbd-ff7feffe-b6ffd7ff-97f9fe7f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x22d14000U,0xf393e8a4U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=56,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>21)&0x97f9fe7fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>21)&0xb6ffd7ffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>21)&0xff7feffeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<8)^((p[b]>>21)&0xffffffbdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt28(uint s) : base(s) { }
    public Sfmt28(uint[]init_key) : base(init_key) { }
}

class Sfmt29 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:16-27-1-5-3:dfffef7f-eff97fdf-fff3fcfa-fe7feeff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x16f44800U,0x24ce4227U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=64,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xfe7feeffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<27);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0xfff3fcfaU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<27);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0xeff97fdfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<27);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0xdfffef7fU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<27);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt29(uint s) : base(s) { }
    public Sfmt29(uint[]init_key) : base(init_key) { }
}

class Sfmt30 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:85-5-7-14-1:ffbfeffe-fbfddbeb-fbdfffff-bfffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0xa7420000U,0xea7b6ca0U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=340,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>14)&0xbfffffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>14)&0xfbdfffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>14)&0xfbfddbebU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^((p[b]>>14)&0xffbfeffeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt30(uint s) : base(s) { }
    public Sfmt30(uint[]init_key) : base(init_key) { }
}

class Sfmt31 : Sfmt
{
    public override string IdString { get {
        return"SFMT-11213:13-15-5-10-3:fffaffff-effef9ff-fe7e9bdb-ff7ffbfe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x42c21400U,0xfde64440U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=52,c=344,d=348; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>10)&0xff7ffbfeU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<15);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>10)&0xfe7e9bdbU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<15);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>10)&0xeffef9ffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<15);
            y=p[a]^((p[b]>>10)&0xfffaffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    public Sfmt31(uint s) : base(s) { }
    public Sfmt31(uint[]init_key) : base(init_key) { }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt1 (unchecked((uint) -1)),
        new Sfmt2 (unchecked((uint) -2)),
        new Sfmt3 (unchecked((uint) -3)),
        new Sfmt4 (unchecked((uint) -4)),
        new Sfmt5 (unchecked((uint) -5)),
        new Sfmt6 (unchecked((uint) -6)),
        new Sfmt7 (unchecked((uint) -7)),
        new Sfmt8 (unchecked((uint) -8)),
        new Sfmt9 (unchecked((uint) -9)),
        new Sfmt10(unchecked((uint)-10)),
        new Sfmt11(unchecked((uint)-11)),
        new Sfmt12(unchecked((uint)-12)),
        new Sfmt13(unchecked((uint)-13)),
        new Sfmt14(unchecked((uint)-14)),
        new Sfmt15(unchecked((uint)-15)),
        new Sfmt16(unchecked((uint)-16)),
        new Sfmt17(unchecked((uint)-17)),
        new Sfmt18(unchecked((uint)-18)),
        new Sfmt19(unchecked((uint)-19)),
        new Sfmt20(unchecked((uint)-20)),
        new Sfmt21(unchecked((uint)-21)),
        new Sfmt22(unchecked((uint)-22)),
        new Sfmt23(unchecked((uint)-23)),
        new Sfmt24(unchecked((uint)-24)),
        new Sfmt25(unchecked((uint)-25)),
        new Sfmt26(unchecked((uint)-26)),
        new Sfmt27(unchecked((uint)-27)),
        new Sfmt28(unchecked((uint)-28)),
        new Sfmt29(unchecked((uint)-29)),
        new Sfmt30(unchecked((uint)-30)),
        new Sfmt31(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

