/*
Sfmt1279.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[40]; /* ԃe[u */

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x20000000U };

    protected virtual uint[]GetParity() { return ParityData; }

    public virtual string IdString { get {
        return"SFMT-1279:7-14-3-5-1:f7fefffd-7fefcfff-aff3ef3f-b5ffff7f";
    } }

    public virtual void gen_rand_all() {
        int a=0,b=28,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xb5ffff7fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xaff3ef3fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0x7fefcfffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xf7fefffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=40; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<40;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<40;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>40) c=key_len+1; else c=40;
            r=x[0]^x[17]^x[39]; r=(r^(r>>27))*1664525;
            x[17]+=r; r+=key_len; x[22]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+17)%40]^x[(i+39)%40];
                r=(r^(r>>27))*1664525; x[(i+17)%40]+=r;
                r+=init_key[j]+i; x[(i+22)%40]+=r;
                x[i]=r; i=(i+1)%40;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+17)%40]^x[(i+39)%40];
                r=(r^(r>>27))*1664525; x[(i+17)%40]+=r; r+=i;
                x[(i+22)%40]+=r; x[i]=r; i=(i+1)%40;
            }
            for (j=0;j<40;j++) {
                r=x[i]+x[(i+17)%40]+x[(i+39)%40];
                r=(r^(r>>27))*1566083941; x[(i+17)%40]^=r;
                r-=i; x[(i+22)%40]^=r; x[i]=r; i=(i+1)%40;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==40) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt1 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:3-18-1-1-1:fffffffb-37f5effb-b3fdaff9-fffffd7d";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x40000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xfffffd7dU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xb3fdaff9U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0x37f5effbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xfffffffbU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt1(uint s) : base(s) { }
    public Sfmt1(uint[]init_key) : base(init_key) { }
}

class Sfmt2 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-21-1-17-1:fffbbfff-fffbdffb-ddfffdff-57ffffbf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>17)&0x57ffffbfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>17)&0xddfffdffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>17)&0xfffbdffbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<8)^((p[b]>>17)&0xfffbbfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt2(uint s) : base(s) { }
    public Sfmt2(uint[]init_key) : base(init_key) { }
}

class Sfmt3 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-19-1-15-1:fbefeffd-ffefffff-dfef7eff-efeeffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>15)&0xefeeffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>15)&0xdfef7effU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>15)&0xffefffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>15)&0xfbefeffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt3(uint s) : base(s) { }
    public Sfmt3(uint[]init_key) : base(init_key) { }
}

class Sfmt4 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:3-20-1-5-1:fddfbf9f-eefffb37-fff7df7b-fffefbef";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xfffefbefU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0xfff7df7bU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0xeefffb37U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0xfddfbf9fU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt4(uint s) : base(s) { }
    public Sfmt4(uint[]init_key) : base(init_key) { }
}

class Sfmt5 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:5-15-3-12-1:fddf9f97-f97fbff7-7fbfbff7-bfbf1fff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x20000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=20,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>12)&0xbfbf1fffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<15);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>12)&0x7fbfbff7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<15);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>12)&0xf97fbff7U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<15);
            y=p[a]^(p[a]<<24)^((p[b]>>12)&0xfddf9f97U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt5(uint s) : base(s) { }
    public Sfmt5(uint[]init_key) : base(init_key) { }
}

class Sfmt6 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-13-3-21-1:fffbffff-fffe96ef-edd7ff2f-f5f7f8ed";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x40000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>21)&0xf5f7f8edU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>21)&0xedd7ff2fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>21)&0xfffe96efU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>21)&0xfffbffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt6(uint s) : base(s) { }
    public Sfmt6(uint[]init_key) : base(init_key) { }
}

class Sfmt7 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-17-3-5-3:afffffff-ff37bffb-e7bdffdd-fffdffdd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xfffdffddU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xe7bdffddU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xff37bffbU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xafffffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt7(uint s) : base(s) { }
    public Sfmt7(uint[]init_key) : base(init_key) { }
}

class Sfmt8 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:2-18-1-11-1:deffffef-deb7effb-df77defe-dfdfd5cf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x40000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>11)&0xdfdfd5cfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>11)&0xdf77defeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>11)&0xdeb7effbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>11)&0xdeffffefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt8(uint s) : base(s) { }
    public Sfmt8(uint[]init_key) : base(init_key) { }
}

class Sfmt9 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-21-1-3-7:fffdfdfe-fbbffeff-ef6fffff-ff7f76ef";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>3)&0xff7f76efU);
            p[a+3]=y^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>3)&0xef6fffffU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>3)&0xfbbffeffU);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<21);
            y=p[a]^(p[a]<<8)^((p[b]>>3)&0xfffdfdfeU);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt9(uint s) : base(s) { }
    public Sfmt9(uint[]init_key) : base(init_key) { }
}

class Sfmt10 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:1-25-1-6-1:eff6fded-fffffdfc-ffffbfff-cfefffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>6)&0xcfefffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<25);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>6)&0xffffbfffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<25);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>6)&0xfffffdfcU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<25);
            y=p[a]^(p[a]<<8)^((p[b]>>6)&0xeff6fdedU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<25);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt10(uint s) : base(s) { }
    public Sfmt10(uint[]init_key) : base(init_key) { }
}

class Sfmt11 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:1-6-3-13-3:ffeecff3-ffffedff-dbf7bfff-d1ffdffd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x20000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0xd1ffdffdU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0xdbf7bfffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0xffffedffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xffeecff3U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt11(uint s) : base(s) { }
    public Sfmt11(uint[]init_key) : base(init_key) { }
}

class Sfmt12 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-6-3-9-1:effff777-eefbfdff-feffffff-fff7fffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>9)&0xfff7fffeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>9)&0xfeffffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>9)&0xeefbfdffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>9)&0xeffff777U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt12(uint s) : base(s) { }
    public Sfmt12(uint[]init_key) : base(init_key) { }
}

class Sfmt13 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:3-13-3-12-5:ffdf7ff7-fff4ffef-edfe5fef-ff7fdfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>12)&0xff7fdfffU);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>12)&0xedfe5fefU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>12)&0xfff4ffefU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>12)&0xffdf7ff7U);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt13(uint s) : base(s) { }
    public Sfmt13(uint[]init_key) : base(init_key) { }
}

class Sfmt14 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:1-19-3-4-1:ff7fffff-fffbfd7f-ffefffea-fddfdfde";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x40000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>4)&0xfddfdfdeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>4)&0xffefffeaU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>4)&0xfffbfd7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<24)^((p[b]>>4)&0xff7fffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt14(uint s) : base(s) { }
    public Sfmt14(uint[]init_key) : base(init_key) { }
}

class Sfmt15 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-6-3-3-5:f7f9f7dd-b7f7beff-f7ffdf7f-ffdff7f9";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xffdff7f9U);
            p[a+3]=y^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xf7ffdf7fU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xb7f7beffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xf7f9f7ddU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt15(uint s) : base(s) { }
    public Sfmt15(uint[]init_key) : base(init_key) { }
}

class Sfmt16 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-5-3-3-3:dfefeffd-dfffffbf-deffb9f7-fffffef7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xfffffef7U);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xdeffb9f7U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xdfffffbfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xdfefeffdU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt16(uint s) : base(s) { }
    public Sfmt16(uint[]init_key) : base(init_key) { }
}

class Sfmt17 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:2-19-3-13-3:fff97fff-6bfff7fe-dafffb7d-efffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0xefffffffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0xdafffb7dU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0x6bfff7feU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<19);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xfff97fffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt17(uint s) : base(s) { }
    public Sfmt17(uint[]init_key) : base(init_key) { }
}

class Sfmt18 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:7-13-7-2-1:7df7ffff-dfd7ff7f-f7f2b3dd-e77ffddf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=28,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>2)&0xe77ffddfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>2)&0xf7f2b3ddU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>2)&0xdfd7ff7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^((p[b]>>2)&0x7df7ffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt18(uint s) : base(s) { }
    public Sfmt18(uint[]init_key) : base(init_key) { }
}

class Sfmt19 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-6-7-5-1:df7ffaff-dffaffff-fdd5bfef-ffd7bfdd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>5)&0xffd7bfddU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>5)&0xfdd5bfefU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>5)&0xdffaffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^((p[b]>>5)&0xdf7ffaffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt19(uint s) : base(s) { }
    public Sfmt19(uint[]init_key) : base(init_key) { }
}

class Sfmt20 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-13-1-1-7:fddbffff-ebffdffc-ffeff7fd-dfdffeff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x10000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xdfdffeffU);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xffeff7fdU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0xebffdffcU);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xfddbffffU);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt20(uint s) : base(s) { }
    public Sfmt20(uint[]init_key) : base(init_key) { }
}

class Sfmt21 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:7-27-1-2-1:fffb67ff-defbe67b-ef1fffff-3effff8f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=28,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>2)&0x3effff8fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<27);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>2)&0xef1fffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<27);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>2)&0xdefbe67bU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<27);
            y=p[a]^(p[a]<<8)^((p[b]>>2)&0xfffb67ffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<27);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt21(uint s) : base(s) { }
    public Sfmt21(uint[]init_key) : base(init_key) { }
}

class Sfmt22 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:4-26-1-3-1:fffdfffa-ffffbfeb-fffdff9a-bfffffdf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=16,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>3)&0xbfffffdfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<26);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>3)&0xfffdff9aU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<26);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>3)&0xffffbfebU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<26);
            y=p[a]^(p[a]<<8)^((p[b]>>3)&0xfffdfffaU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<26);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt22(uint s) : base(s) { }
    public Sfmt22(uint[]init_key) : base(init_key) { }
}

class Sfmt23 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:7-11-3-12-5:fdfeedff-dffcfff7-7bdffffe-ffdfffea";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=28,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>12)&0xffdfffeaU);
            p[a+3]=y^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>12)&0x7bdffffeU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>12)&0xdffcfff7U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>12)&0xfdfeedffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt23(uint s) : base(s) { }
    public Sfmt23(uint[]init_key) : base(init_key) { }
}

class Sfmt24 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-5-7-11-1:4fdffdff-c7feff7f-f5ffbe7f-3fddff97";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>11)&0x3fddff97U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>11)&0xf5ffbe7fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>11)&0xc7feff7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^((p[b]>>11)&0x4fdffdffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt24(uint s) : base(s) { }
    public Sfmt24(uint[]init_key) : base(init_key) { }
}

class Sfmt25 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-13-1-5-3:ffdffbae-7ffbff3f-ffffab5b-e7fff35b";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xe7fff35bU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0xffffab5bU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0x7ffbff3fU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0xffdffbaeU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt25(uint s) : base(s) { }
    public Sfmt25(uint[]init_key) : base(init_key) { }
}

class Sfmt26 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:2-12-5-3-3:bfdefeef-bffffeff-fffefffb-fbfbdffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>3)&0xfbfbdffeU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<12);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>3)&0xfffefffbU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<12);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>3)&0xbffffeffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<12);
            y=p[a]^((p[b]>>3)&0xbfdefeefU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt26(uint s) : base(s) { }
    public Sfmt26(uint[]init_key) : base(init_key) { }
}

class Sfmt27 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-3-3-5-3:fffffff3-f7bbffff-fafff9fb-ff77fddf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x80000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xff77fddfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xfafff9fbU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xf7bbffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xfffffff3U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt27(uint s) : base(s) { }
    public Sfmt27(uint[]init_key) : base(init_key) { }
}

class Sfmt28 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-19-1-7-3:fdffefff-5ffbdffd-efbbfff3-ff7e7bb7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>7)&0xff7e7bb7U);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>7)&0xefbbfff3U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>7)&0x5ffbdffdU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>7)&0xfdffefffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt28(uint s) : base(s) { }
    public Sfmt28(uint[]init_key) : base(init_key) { }
}

class Sfmt29 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:8-11-1-5-3:7eafebff-7fdfdefd-b7d7bff5-f7bb7ff7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x40000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xf7bb7ff7U);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0xb7d7bff5U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0x7fdfdefdU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0x7eafebffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt29(uint s) : base(s) { }
    public Sfmt29(uint[]init_key) : base(init_key) { }
}

class Sfmt30 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:6-14-1-3-7:ffffbffd-fffbffdf-ffffffff-fedffde5";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>3)&0xfedffde5U);
            p[a+3]=y^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>3)&0xffffffffU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>3)&0xfffbffdfU);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<14);
            y=p[a]^(p[a]<<8)^((p[b]>>3)&0xffffbffdU);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt30(uint s) : base(s) { }
    public Sfmt30(uint[]init_key) : base(init_key) { }
}

class Sfmt31 : Sfmt
{
    public override string IdString { get {
        return"SFMT-1279:3-5-3-22-5:cffdffdf-ffff6eff-fff5fff7-efffbfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x00000000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=32,d=36; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>22)&0xefffbfffU);
            p[a+3]=y^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>22)&0xfff5fff7U);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>22)&0xffff6effU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>22)&0xcffdffdfU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    public Sfmt31(uint s) : base(s) { }
    public Sfmt31(uint[]init_key) : base(init_key) { }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt1 (unchecked((uint) -1)),
        new Sfmt2 (unchecked((uint) -2)),
        new Sfmt3 (unchecked((uint) -3)),
        new Sfmt4 (unchecked((uint) -4)),
        new Sfmt5 (unchecked((uint) -5)),
        new Sfmt6 (unchecked((uint) -6)),
        new Sfmt7 (unchecked((uint) -7)),
        new Sfmt8 (unchecked((uint) -8)),
        new Sfmt9 (unchecked((uint) -9)),
        new Sfmt10(unchecked((uint)-10)),
        new Sfmt11(unchecked((uint)-11)),
        new Sfmt12(unchecked((uint)-12)),
        new Sfmt13(unchecked((uint)-13)),
        new Sfmt14(unchecked((uint)-14)),
        new Sfmt15(unchecked((uint)-15)),
        new Sfmt16(unchecked((uint)-16)),
        new Sfmt17(unchecked((uint)-17)),
        new Sfmt18(unchecked((uint)-18)),
        new Sfmt19(unchecked((uint)-19)),
        new Sfmt20(unchecked((uint)-20)),
        new Sfmt21(unchecked((uint)-21)),
        new Sfmt22(unchecked((uint)-22)),
        new Sfmt23(unchecked((uint)-23)),
        new Sfmt24(unchecked((uint)-24)),
        new Sfmt25(unchecked((uint)-25)),
        new Sfmt26(unchecked((uint)-26)),
        new Sfmt27(unchecked((uint)-27)),
        new Sfmt28(unchecked((uint)-28)),
        new Sfmt29(unchecked((uint)-29)),
        new Sfmt30(unchecked((uint)-30)),
        new Sfmt31(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

