/*
Sfmt19937.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[624]; /* ԃe[u */

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x13c9e684U };

    protected virtual uint[]GetParity() { return ParityData; }

    public virtual string IdString { get {
        return"SFMT-19937:122-18-1-11-1:dfffffef-ddfecb7f-bffaffff-bffffff6";
    } }

    public virtual void gen_rand_all() {
        int a=0,b=488,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>11)&0xbffffff6U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>11)&0xbffaffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>11)&0xddfecb7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>11)&0xdfffffefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=624; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<624;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<624;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>624) c=key_len+1; else c=624;
            r=x[0]^x[306]^x[623]; r=(r^(r>>27))*1664525;
            x[306]+=r; r+=key_len; x[317]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+306)%624]^x[(i+623)%624];
                r=(r^(r>>27))*1664525; x[(i+306)%624]+=r;
                r+=init_key[j]+i; x[(i+317)%624]+=r;
                x[i]=r; i=(i+1)%624;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+306)%624]^x[(i+623)%624];
                r=(r^(r>>27))*1664525; x[(i+306)%624]+=r; r+=i;
                x[(i+317)%624]+=r; x[i]=r; i=(i+1)%624;
            }
            for (j=0;j<624;j++) {
                r=x[i]+x[(i+306)%624]+x[(i+623)%624];
                r=(r^(r>>27))*1566083941; x[(i+306)%624]^=r;
                r-=i; x[(i+317)%624]^=r; x[i]=r; i=(i+1)%624;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==624) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt1 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:73-11-3-4-1:efefffff-ef7dfffb-bcfffeff-fdffffc7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xfbdf63e3U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=292,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>4)&0xfdffffc7U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>4)&0xbcfffeffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>4)&0xef7dfffbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>4)&0xefefffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt1(uint s) : base(s) { }
    public Sfmt1(uint[]init_key) : base(init_key) { }
}

class Sfmt2 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:60-10-3-3-1:effdbfff-dfffffff-efffbfef-ffef77ff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xdc0d7984U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=240,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xffef77ffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xefffbfefU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xdfffffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xeffdbfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt2(uint s) : base(s) { }
    public Sfmt2(uint[]init_key) : base(init_key) { }
}

class Sfmt3 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:45-14-3-5-5:aefefbbd-feffffff-d7edffff-f7fdffbe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x0116914cU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=180,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xf7fdffbeU);
            p[a+3]=y^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xd7edffffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xfeffffffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xaefefbbdU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt3(uint s) : base(s) { }
    public Sfmt3(uint[]init_key) : base(init_key) { }
}

class Sfmt4 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:135-18-1-1-1:ffffdffe-fffefffb-bfbfffff-fffffdff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0x978e01e2U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=540,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xfffffdffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xbfbfffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0xfffefffbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xffffdffeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt4(uint s) : base(s) { }
    public Sfmt4(uint[]init_key) : base(init_key) { }
}

class Sfmt5 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:120-18-1-1-1:ffefef5d-ff25ff7d-eebfefee-fabfdfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x02000000U,0xc9bbd290U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=480,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xfabfdfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xeebfefeeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0xff25ff7dU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xffefef5dU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt5(uint s) : base(s) { }
    public Sfmt5(uint[]init_key) : base(init_key) { }
}

class Sfmt6 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:33-14-3-5-1:fdff7ffd-fbffee71-fb3ff7df-deffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x8f2cf308U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=132,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xdeffffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xfb3ff7dfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xfbffee71U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xfdff7ffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt6(uint s) : base(s) { }
    public Sfmt6(uint[]init_key) : base(init_key) { }
}

class Sfmt7 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:122-12-3-3-5:fef73bff-65eb7ff7-76ffffff-bfdeffeb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0x2bbdd900U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=488,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xbfdeffebU);
            p[a+3]=y^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0x76ffffffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0x65eb7ff7U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xfef73bffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt7(uint s) : base(s) { }
    public Sfmt7(uint[]init_key) : base(init_key) { }
}

class Sfmt8 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:64-10-3-13-1:fff8bfff-ffffffff-5fffffbf-ef7ff21e";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xdb186980U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=256,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0xef7ff21eU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0x5fffffbfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0xffffffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xfff8bfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt8(uint s) : base(s) { }
    public Sfmt8(uint[]init_key) : base(init_key) { }
}

class Sfmt9 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:29-21-1-2-1:5fffffdf-ffffcfff-bdffdefe-fdfdffbf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x21a2acc8U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=116,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>2)&0xfdfdffbfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>2)&0xbdffdefeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>2)&0xffffcfffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<8)^((p[b]>>2)&0x5fffffdfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt9(uint s) : base(s) { }
    public Sfmt9(uint[]init_key) : base(init_key) { }
}

class Sfmt10 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:128-11-3-1-5:7dbebfff-7ffffffe-ded6ffef-fefeff6e";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x42530085U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=512,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>1)&0xfefeff6eU);
            p[a+3]=y^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>1)&0xded6ffefU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>1)&0x7ffffffeU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>1)&0x7dbebfffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt10(uint s) : base(s) { }
    public Sfmt10(uint[]init_key) : base(init_key) { }
}

class Sfmt11 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:106-19-1-9-1:ffeeffdf-ffffdfff-bd6ff9ff-fdafebff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x47a2caf4U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=424,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>9)&0xfdafebffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>9)&0xbd6ff9ffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>9)&0xffffdfffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>9)&0xffeeffdfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt11(uint s) : base(s) { }
    public Sfmt11(uint[]init_key) : base(init_key) { }
}

class Sfmt12 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:75-9-3-4-3:fffeffff-ffeff7df-bbbffeef-bfbffeff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x0b6f3e5cU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=300,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>4)&0xbfbffeffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>4)&0xbbbffeefU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>4)&0xffeff7dfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>4)&0xfffeffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt12(uint s) : base(s) { }
    public Sfmt12(uint[]init_key) : base(init_key) { }
}

class Sfmt13 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:85-10-3-5-5:bdfffbef-efedffef-aff9f7fe-befbfffd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x8eddf8b2U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=340,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xbefbfffdU);
            p[a+3]=y^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xaff9f7feU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xefedffefU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xbdfffbefU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt13(uint s) : base(s) { }
    public Sfmt13(uint[]init_key) : base(init_key) { }
}

class Sfmt14 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:27-21-1-12-1:bf7dffdf-c97dff7b-f7fdfbfd-f7bffbaf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x539ef018U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=108,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>12)&0xf7bffbafU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>12)&0xf7fdfbfdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>12)&0xc97dff7bU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<8)^((p[b]>>12)&0xbf7dffdfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt14(uint s) : base(s) { }
    public Sfmt14(uint[]init_key) : base(init_key) { }
}

class Sfmt15 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:12-13-3-3-1:ffffffbb-fffff7ab-fdfff7c2-bdff9efb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xa631116aU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=48,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xbdff9efbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xfdfff7c2U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xfffff7abU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xffffffbbU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt15(uint s) : base(s) { }
    public Sfmt15(uint[]init_key) : base(init_key) { }
}

class Sfmt16 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:92-9-3-5-3:cfffbbff-fffffff7-fff7ffef-ff9fffdf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xfb62abccU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=368,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xff9fffdfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xfff7ffefU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xfffffff7U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xcfffbbffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt16(uint s) : base(s) { }
    public Sfmt16(uint[]init_key) : base(init_key) { }
}

class Sfmt17 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:124-13-3-11-1:ffbff7ef-7b7e7fcd-fddaff7f-b7dbfdfc";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x02889855U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=496,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xb7dbfdfcU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xfddaff7fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0x7b7e7fcdU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xffbff7efU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt17(uint s) : base(s) { }
    public Sfmt17(uint[]init_key) : base(init_key) { }
}

class Sfmt18 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:112-20-1-15-1:ffbf7efe-fabf7fff-f6ff7fef-f74f6f3f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x921dce22U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=448,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>15)&0xf74f6f3fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>15)&0xf6ff7fefU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>15)&0xfabf7fffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>15)&0xffbf7efeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt18(uint s) : base(s) { }
    public Sfmt18(uint[]init_key) : base(init_key) { }
}

class Sfmt19 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:130-9-3-13-1:dfbf1ffd-f7feefdd-fffbffff-96ffffdf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xda18b200U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=520,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0x96ffffdfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0xfffbffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0xf7feefddU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xdfbf1ffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt19(uint s) : base(s) { }
    public Sfmt19(uint[]init_key) : base(init_key) { }
}

class Sfmt20 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:125-11-3-16-3:bfdfffff-7fffbe7f-bbfffff7-f7fdddff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0x63cd4800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=500,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>16)&0xf7fdddffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>16)&0xbbfffff7U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>16)&0x7fffbe7fU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>16)&0xbfdfffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt20(uint s) : base(s) { }
    public Sfmt20(uint[]init_key) : base(init_key) { }
}

class Sfmt21 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:4-20-1-1-1:fffef7f9-ffdff7fb-cbfff7fe-edfefffd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0xd71cbdcaU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=16,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xedfefffdU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xcbfff7feU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0xffdff7fbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xfffef7f9U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt21(uint s) : base(s) { }
    public Sfmt21(uint[]init_key) : base(init_key) { }
}

class Sfmt22 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:123-16-3-3-1:bd7feffd-bfffffff-fffcf6ff-5ffcffeb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x09d68a18U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=492,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0x5ffcffebU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<16);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xfffcf6ffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<16);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xbfffffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<16);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xbd7feffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<16);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt22(uint s) : base(s) { }
    public Sfmt22(uint[]init_key) : base(init_key) { }
}

class Sfmt23 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:97-14-1-11-1:efdfceff-eddffdff-efdfef7f-ffb7ffdf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xc491f160U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=388,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>11)&0xffb7ffdfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>11)&0xefdfef7fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>11)&0xeddffdffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<8)^((p[b]>>11)&0xefdfceffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt23(uint s) : base(s) { }
    public Sfmt23(uint[]init_key) : base(init_key) { }
}

class Sfmt24 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:2-13-3-11-1:fdffbffd-fff3b33f-fff7ff7e-ffdfef7f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0xad42c1d1U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xffdfef7fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xfff7ff7eU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xfff3b33fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xfdffbffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt24(uint s) : base(s) { }
    public Sfmt24(uint[]init_key) : base(init_key) { }
}

class Sfmt25 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:153-11-3-4-3:ffebf7fd-fffdffff-ffffffef-fffbdfb7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x7f72515eU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=612,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>4)&0xfffbdfb7U);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>4)&0xffffffefU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>4)&0xfffdffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>4)&0xffebf7fdU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt25(uint s) : base(s) { }
    public Sfmt25(uint[]init_key) : base(init_key) { }
}

class Sfmt26 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:64-7-7-7-1:fbbefeef-ffffffc7-fbffed57-fafffddf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x7094862aU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=256,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>7)&0xfafffddfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>7)&0xfbffed57U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>7)&0xffffffc7U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^((p[b]>>7)&0xfbbefeefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt26(uint s) : base(s) { }
    public Sfmt26(uint[]init_key) : base(init_key) { }
}

class Sfmt27 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:150-7-3-3-1:ffff7fef-ffbf5aff-a6ff7fbd-bffffbff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0x5ee9dc90U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=600,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xbffffbffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xa6ff7fbdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xffbf5affU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xffff7fefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt27(uint s) : base(s) { }
    public Sfmt27(uint[]init_key) : base(init_key) { }
}

class Sfmt28 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:150-16-3-3-1:fdbffaed-ffc7f69f-67f7ffbe-bf7bbf7e";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xb6a0c2e9U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=600,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xbf7bbf7eU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<16);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0x67f7ffbeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<16);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xffc7f69fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<16);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xfdbffaedU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<16);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt28(uint s) : base(s) { }
    public Sfmt28(uint[]init_key) : base(init_key) { }
}

class Sfmt29 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:110-17-3-9-3:bffffffb-7b7fffff-ffffdf5f-fbffdeff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x20000000U,0x4bf4dbf0U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=440,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>9)&0xfbffdeffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>9)&0xffffdf5fU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>9)&0x7b7fffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>9)&0xbffffffbU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt29(uint s) : base(s) { }
    public Sfmt29(uint[]init_key) : base(init_key) { }
}

class Sfmt30 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:22-5-3-7-1:bb5fffff-be7fdfff-fe7fffdf-6ffaffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x43471de2U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=88,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>7)&0x6ffaffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>7)&0xfe7fffdfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>7)&0xbe7fdfffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>7)&0xbb5fffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt30(uint s) : base(s) { }
    public Sfmt30(uint[]init_key) : base(init_key) { }
}

class Sfmt31 : Sfmt
{
    public override string IdString { get {
        return"SFMT-19937:104-9-7-13-1:bfefefeb-77f7efbf-f5ffff7e-fffffffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xc4cda29cU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=416,c=616,d=620; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>13)&0xfffffffeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>13)&0xf5ffff7eU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>13)&0x77f7efbfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^((p[b]>>13)&0xbfefefebU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    public Sfmt31(uint s) : base(s) { }
    public Sfmt31(uint[]init_key) : base(init_key) { }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt1 (unchecked((uint) -1)),
        new Sfmt2 (unchecked((uint) -2)),
        new Sfmt3 (unchecked((uint) -3)),
        new Sfmt4 (unchecked((uint) -4)),
        new Sfmt5 (unchecked((uint) -5)),
        new Sfmt6 (unchecked((uint) -6)),
        new Sfmt7 (unchecked((uint) -7)),
        new Sfmt8 (unchecked((uint) -8)),
        new Sfmt9 (unchecked((uint) -9)),
        new Sfmt10(unchecked((uint)-10)),
        new Sfmt11(unchecked((uint)-11)),
        new Sfmt12(unchecked((uint)-12)),
        new Sfmt13(unchecked((uint)-13)),
        new Sfmt14(unchecked((uint)-14)),
        new Sfmt15(unchecked((uint)-15)),
        new Sfmt16(unchecked((uint)-16)),
        new Sfmt17(unchecked((uint)-17)),
        new Sfmt18(unchecked((uint)-18)),
        new Sfmt19(unchecked((uint)-19)),
        new Sfmt20(unchecked((uint)-20)),
        new Sfmt21(unchecked((uint)-21)),
        new Sfmt22(unchecked((uint)-22)),
        new Sfmt23(unchecked((uint)-23)),
        new Sfmt24(unchecked((uint)-24)),
        new Sfmt25(unchecked((uint)-25)),
        new Sfmt26(unchecked((uint)-26)),
        new Sfmt27(unchecked((uint)-27)),
        new Sfmt28(unchecked((uint)-28)),
        new Sfmt29(unchecked((uint)-29)),
        new Sfmt30(unchecked((uint)-30)),
        new Sfmt31(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

