/*
Sfmt2281.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[72]; /* ԃe[u */

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x41dfa600U };

    protected virtual uint[]GetParity() { return ParityData; }

    public virtual string IdString { get {
        return"SFMT-2281:12-19-1-5-1:bff7ffbf-fdfffffe-f7ffef7f-f2f7cbbf";
    } }

    public virtual void gen_rand_all() {
        int a=0,b=48,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xf2f7cbbfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0xf7ffef7fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0xfdfffffeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0xbff7ffbfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=72; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<72;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<72;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>72) c=key_len+1; else c=72;
            r=x[0]^x[32]^x[71]; r=(r^(r>>27))*1664525;
            x[32]+=r; r+=key_len; x[39]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+32)%72]^x[(i+71)%72];
                r=(r^(r>>27))*1664525; x[(i+32)%72]+=r;
                r+=init_key[j]+i; x[(i+39)%72]+=r;
                x[i]=r; i=(i+1)%72;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+32)%72]^x[(i+71)%72];
                r=(r^(r>>27))*1664525; x[(i+32)%72]+=r; r+=i;
                x[(i+39)%72]+=r; x[i]=r; i=(i+1)%72;
            }
            for (j=0;j<72;j++) {
                r=x[i]+x[(i+32)%72]+x[(i+71)%72];
                r=(r^(r>>27))*1566083941; x[(i+32)%72]^=r;
                r-=i; x[(i+39)%72]^=r; x[i]=r; i=(i+1)%72;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==72) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt1 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:12-10-3-5-1:fbdffff7-cfbffffe-fdfffffb-bcdffffb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x92730900U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=48,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xbcdffffbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xfdfffffbU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xcfbffffeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xfbdffff7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt1(uint s) : base(s) { }
    public Sfmt1(uint[]init_key) : base(init_key) { }
}

class Sfmt2 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:7-9-3-4-1:dfffef7b-ffefffff-fcfeffff-b6ff77cf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x907c9c00U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=28,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>4)&0xb6ff77cfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>4)&0xfcfeffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>4)&0xffefffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>4)&0xdfffef7bU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt2(uint s) : base(s) { }
    public Sfmt2(uint[]init_key) : base(init_key) { }
}

class Sfmt3 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:8-10-3-7-1:dbffedff-fffbfffd-f7ffffdf-ffff7ff7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x0a826800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>7)&0xffff7ff7U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>7)&0xf7ffffdfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>7)&0xfffbfffdU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>7)&0xdbffedffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt3(uint s) : base(s) { }
    public Sfmt3(uint[]init_key) : base(init_key) { }
}

class Sfmt4 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:5-10-3-9-5:3f7ffbff-fffffff9-bffffbfe-9ffff7ff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x92e7de00U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=20,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>9)&0x9ffff7ffU);
            p[a+3]=y^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>9)&0xbffffbfeU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>9)&0xfffffff9U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>9)&0x3f7ffbffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt4(uint s) : base(s) { }
    public Sfmt4(uint[]init_key) : base(init_key) { }
}

class Sfmt5 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:10-10-3-9-3:ff9ffff7-fdffffff-bf3f7fff-fbffff7c";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xc66e2000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=40,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>9)&0xfbffff7cU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>9)&0xbf3f7fffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>9)&0xfdffffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>9)&0xff9ffff7U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt5(uint s) : base(s) { }
    public Sfmt5(uint[]init_key) : base(init_key) { }
}

class Sfmt6 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:11-8-3-5-5:ff6ffba9-fffff7f7-ffdfdfff-f2ffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x1b40e800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=44,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>5)&0xf2ffffffU);
            p[a+3]=y^(p[d+3]<<8);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>5)&0xffdfdfffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<8);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>5)&0xfffff7f7U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<8);
            y=p[a]^(p[a]<<24)^((p[b]>>5)&0xff6ffba9U);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<8);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt6(uint s) : base(s) { }
    public Sfmt6(uint[]init_key) : base(init_key) { }
}

class Sfmt7 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:3-14-3-11-5:7bffffdf-3ffb7fdb-3f777ffb-fffefdbb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x3530d200U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xfffefdbbU);
            p[a+3]=y^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0x3f777ffbU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0x3ffb7fdbU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0x7bffffdfU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt7(uint s) : base(s) { }
    public Sfmt7(uint[]init_key) : base(init_key) { }
}

class Sfmt8 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:11-14-7-5-1:f7bffff9-6efff7ff-fbfbffdf-fff8ffbf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x48acb400U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=44,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>5)&0xfff8ffbfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>5)&0xfbfbffdfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>5)&0x6efff7ffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^((p[b]>>5)&0xf7bffff9U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt8(uint s) : base(s) { }
    public Sfmt8(uint[]init_key) : base(init_key) { }
}

class Sfmt9 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:2-20-1-5-3:ffffffbf-7dffdfeb-df7fffdf-feff69ee";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x32455000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>5)&0xfeff69eeU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>5)&0xdf7fffdfU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>5)&0x7dffdfebU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>5)&0xffffffbfU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt9(uint s) : base(s) { }
    public Sfmt9(uint[]init_key) : base(init_key) { }
}

class Sfmt10 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:5-10-3-15-5:fff3ecfd-ffffff77-9f9fadff-b9d3ebdd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xb05f9800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=20,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>15)&0xb9d3ebddU);
            p[a+3]=y^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>15)&0x9f9fadffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>15)&0xffffff77U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>15)&0xfff3ecfdU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt10(uint s) : base(s) { }
    public Sfmt10(uint[]init_key) : base(init_key) { }
}

class Sfmt11 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:15-13-1-4-1:ffffff1b-ffbff77b-bfbffffe-fffbfaf5";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x27b07600U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=60,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>4)&0xfffbfaf5U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>4)&0xbfbffffeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>4)&0xffbff77bU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>4)&0xffffff1bU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt11(uint s) : base(s) { }
    public Sfmt11(uint[]init_key) : base(init_key) { }
}

class Sfmt12 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:5-5-3-6-1:dfff7dff-ff79fffe-eff77ffd-effb75df";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xc22bf800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=20,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>6)&0xeffb75dfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>6)&0xeff77ffdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>6)&0xff79fffeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>6)&0xdfff7dffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt12(uint s) : base(s) { }
    public Sfmt12(uint[]init_key) : base(init_key) { }
}

class Sfmt13 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:16-18-5-1-1:7ffffbff-fffff7bf-df7e6fff-fff7cfcf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x3d350a80U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=64,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>1)&0xfff7cfcfU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>1)&0xdf7e6fffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>1)&0xfffff7bfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^((p[b]>>1)&0x7ffffbffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt13(uint s) : base(s) { }
    public Sfmt13(uint[]init_key) : base(init_key) { }
}

class Sfmt14 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:15-19-3-14-1:ffffdbbf-cbf7ffff-fffebbfd-befebfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x147a0200U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=60,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>14)&0xbefebfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>14)&0xfffebbfdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>14)&0xcbf7ffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<24)^((p[b]>>14)&0xffffdbbfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt14(uint s) : base(s) { }
    public Sfmt14(uint[]init_key) : base(init_key) { }
}

class Sfmt15 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:9-10-7-13-1:dfffeeef-fffffddf-fbfbfe5f-cffbfdef";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xdb3cce00U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=36,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>13)&0xcffbfdefU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>13)&0xfbfbfe5fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>13)&0xfffffddfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^((p[b]>>13)&0xdfffeeefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt15(uint s) : base(s) { }
    public Sfmt15(uint[]init_key) : base(init_key) { }
}

class Sfmt16 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:4-14-3-13-1:d7ffffdf-bfdfffff-fbfffdfe-5ffbffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x011ecc00U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=16,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0x5ffbffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0xfbfffdfeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0xbfdfffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xd7ffffdfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt16(uint s) : base(s) { }
    public Sfmt16(uint[]init_key) : base(init_key) { }
}

class Sfmt17 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:1-11-3-24-1:f3fbbfff-bffffffb-df7fd7bd-ff7edffd";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x07aee200U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>24)&0xff7edffdU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>24)&0xdf7fd7bdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>24)&0xbffffffbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>24)&0xf3fbbfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt17(uint s) : base(s) { }
    public Sfmt17(uint[]init_key) : base(init_key) { }
}

class Sfmt18 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:6-9-7-21-1:beddbdff-fbffbd7f-f95b7fff-7fefbfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x197e2080U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=24,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>21)&0x7fefbfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>21)&0xf95b7fffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>21)&0xfbffbd7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^((p[b]>>21)&0xbeddbdffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt18(uint s) : base(s) { }
    public Sfmt18(uint[]init_key) : base(init_key) { }
}

class Sfmt19 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:1-9-3-12-1:eff7fcfa-f3ee7fef-bdb47dff-dbf6dfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x2bbd0a00U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>12)&0xdbf6dfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>12)&0xbdb47dffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>12)&0xf3ee7fefU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>12)&0xeff7fcfaU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt19(uint s) : base(s) { }
    public Sfmt19(uint[]init_key) : base(init_key) { }
}

class Sfmt20 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:1-18-5-7-3:efffffe7-ffffdfdf-ffffffff-5fff4aff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x8a50e100U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>7)&0x5fff4affU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<18);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>7)&0xffffffffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<18);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>7)&0xffffdfdfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<18);
            y=p[a]^((p[b]>>7)&0xefffffe7U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt20(uint s) : base(s) { }
    public Sfmt20(uint[]init_key) : base(init_key) { }
}

class Sfmt21 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:11-19-7-12-3:f7bfffff-eddfffff-f77ffd7f-eff7ffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x502bdc20U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=44,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>12)&0xeff7ffffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<19);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>12)&0xf77ffd7fU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<19);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>12)&0xeddfffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<19);
            y=p[a]^((p[b]>>12)&0xf7bfffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt21(uint s) : base(s) { }
    public Sfmt21(uint[]init_key) : base(init_key) { }
}

class Sfmt22 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:10-19-3-17-1:effbdfff-fffdbeed-fefd3fbf-ff5beffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xdedc0400U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=40,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>17)&0xff5beffeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>17)&0xfefd3fbfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>17)&0xfffdbeedU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<24)^((p[b]>>17)&0xeffbdfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt22(uint s) : base(s) { }
    public Sfmt22(uint[]init_key) : base(init_key) { }
}

class Sfmt23 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:11-17-7-20-1:bdffddfd-dfdffffc-bffeffd6-ff7fffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x3923e800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=44,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>20)&0xff7fffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<17);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>20)&0xbffeffd6U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<17);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>20)&0xdfdffffcU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<17);
            y=p[a]^((p[b]>>20)&0xbdffddfdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt23(uint s) : base(s) { }
    public Sfmt23(uint[]init_key) : base(init_key) { }
}

class Sfmt24 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:9-21-3-20-5:ffffffdf-dfffffff-ff6ffffa-ffffdfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x8a9b2080U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=36,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>20)&0xffffdfffU);
            p[a+3]=y^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>20)&0xff6ffffaU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>20)&0xdfffffffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>20)&0xffffffdfU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt24(uint s) : base(s) { }
    public Sfmt24(uint[]init_key) : base(init_key) { }
}

class Sfmt25 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:5-4-7-19-1:ffbfbfff-ffffbfff-fff7ceee-ffffefff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x859df000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=20,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>19)&0xffffefffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<4);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>19)&0xfff7ceeeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<4);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>19)&0xffffbfffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<4);
            y=p[a]^((p[b]>>19)&0xffbfbfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<4);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt25(uint s) : base(s) { }
    public Sfmt25(uint[]init_key) : base(init_key) { }
}

class Sfmt26 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:3-2-7-1-1:fffefbef-7ffffbf7-ffffffff-6fff7fff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xcc1df840U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>1)&0x6fff7fffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<2);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>1)&0xffffffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<2);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>1)&0x7ffffbf7U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<2);
            y=p[a]^((p[b]>>1)&0xfffefbefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<2);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt26(uint s) : base(s) { }
    public Sfmt26(uint[]init_key) : base(init_key) { }
}

class Sfmt27 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:14-20-7-9-1:7bffc3f9-ddfff2fb-ddfbf6fb-77dfdfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xf6dae320U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=56,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>9)&0x77dfdfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>9)&0xddfbf6fbU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>9)&0xddfff2fbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^((p[b]>>9)&0x7bffc3f9U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt27(uint s) : base(s) { }
    public Sfmt27(uint[]init_key) : base(init_key) { }
}

class Sfmt28 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:3-2-3-19-1:bbfffcff-f7bffcdf-e39ffffd-f7bebfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xd324a000U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>19)&0xf7bebfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<2);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>19)&0xe39ffffdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<2);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>19)&0xf7bffcdfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<2);
            y=p[a]^(p[a]<<24)^((p[b]>>19)&0xbbfffcffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<2);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt28(uint s) : base(s) { }
    public Sfmt28(uint[]init_key) : base(init_key) { }
}

class Sfmt29 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:2-9-7-17-1:ffffffff-7fbff9df-7f6fefcf-efffffde";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xcb8f6a00U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>17)&0xefffffdeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>17)&0x7f6fefcfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>17)&0x7fbff9dfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^((p[b]>>17)&0xffffffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt29(uint s) : base(s) { }
    public Sfmt29(uint[]init_key) : base(init_key) { }
}

class Sfmt30 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:15-12-1-1-7:fdffffff-ffffdef7-ff3fffff-f37776f7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x16537800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=60,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xf37776f7U);
            p[a+3]=y^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xff3fffffU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0xffffdef7U);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<12);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xfdffffffU);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt30(uint s) : base(s) { }
    public Sfmt30(uint[]init_key) : base(init_key) { }
}

class Sfmt31 : Sfmt
{
    public override string IdString { get {
        return"SFMT-2281:9-11-5-6-3:e7fffba3-ffdf7fdf-efbf7fff-fd7cf7bf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xc4cbc800U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=36,c=64,d=68; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>6)&0xfd7cf7bfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>6)&0xefbf7fffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>6)&0xffdf7fdfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>6)&0xe7fffba3U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    public Sfmt31(uint s) : base(s) { }
    public Sfmt31(uint[]init_key) : base(init_key) { }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt1 (unchecked((uint) -1)),
        new Sfmt2 (unchecked((uint) -2)),
        new Sfmt3 (unchecked((uint) -3)),
        new Sfmt4 (unchecked((uint) -4)),
        new Sfmt5 (unchecked((uint) -5)),
        new Sfmt6 (unchecked((uint) -6)),
        new Sfmt7 (unchecked((uint) -7)),
        new Sfmt8 (unchecked((uint) -8)),
        new Sfmt9 (unchecked((uint) -9)),
        new Sfmt10(unchecked((uint)-10)),
        new Sfmt11(unchecked((uint)-11)),
        new Sfmt12(unchecked((uint)-12)),
        new Sfmt13(unchecked((uint)-13)),
        new Sfmt14(unchecked((uint)-14)),
        new Sfmt15(unchecked((uint)-15)),
        new Sfmt16(unchecked((uint)-16)),
        new Sfmt17(unchecked((uint)-17)),
        new Sfmt18(unchecked((uint)-18)),
        new Sfmt19(unchecked((uint)-19)),
        new Sfmt20(unchecked((uint)-20)),
        new Sfmt21(unchecked((uint)-21)),
        new Sfmt22(unchecked((uint)-22)),
        new Sfmt23(unchecked((uint)-23)),
        new Sfmt24(unchecked((uint)-24)),
        new Sfmt25(unchecked((uint)-25)),
        new Sfmt26(unchecked((uint)-26)),
        new Sfmt27(unchecked((uint)-27)),
        new Sfmt28(unchecked((uint)-28)),
        new Sfmt29(unchecked((uint)-29)),
        new Sfmt30(unchecked((uint)-30)),
        new Sfmt31(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

