/*
Sfmt4253.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[136]; /* ԃe[u */

    static uint[]ParityData=
    { 0xa8000001U,0xaf5390a3U,0xb740b3f8U,0x6c11486dU };

    protected virtual uint[]GetParity() { return ParityData; }

    public virtual string IdString { get {
        return"SFMT-4253:17-20-1-7-1:9f7bffff-9fffff5f-3efffffb-fffff7bb";
    } }

    public virtual void gen_rand_all() {
        int a=0,b=68,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>7)&0xfffff7bbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>7)&0x3efffffbU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>7)&0x9fffff5fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>7)&0x9f7bffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=136; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<136;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<136;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>136) c=key_len+1; else c=136;
            r=x[0]^x[64]^x[135]; r=(r^(r>>27))*1664525;
            x[64]+=r; r+=key_len; x[71]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+64)%136]^x[(i+135)%136];
                r=(r^(r>>27))*1664525; x[(i+64)%136]+=r;
                r+=init_key[j]+i; x[(i+71)%136]+=r;
                x[i]=r; i=(i+1)%136;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+64)%136]^x[(i+135)%136];
                r=(r^(r>>27))*1664525; x[(i+64)%136]+=r; r+=i;
                x[(i+71)%136]+=r; x[i]=r; i=(i+1)%136;
            }
            for (j=0;j<136;j++) {
                r=x[i]+x[(i+64)%136]+x[(i+135)%136];
                r=(r^(r>>27))*1566083941; x[(i+64)%136]^=r;
                r-=i; x[(i+71)%136]^=r; x[i]=r; i=(i+1)%136;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==136) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt1 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:25-10-3-1-3:daeeedf7-fff4eff7-ffffebfe-eff7febf";
    } }

    static uint[]ParityData=
    { 0xc0000001U,0x078d2186U,0xe690a4a9U,0x7a5efbe5U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=100,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>1)&0xeff7febfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>1)&0xffffebfeU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>1)&0xfff4eff7U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>1)&0xdaeeedf7U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt1(uint s) : base(s) { }
    public Sfmt1(uint[]init_key) : base(init_key) { }
}

class Sfmt2 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:15-25-1-2-1:dffff3ff-ffdebf7f-ffdfbdf7-fbffffff";
    } }

    static uint[]ParityData=
    { 0x20000001U,0x8b4ecd15U,0xb3480fc1U,0x35ab1967U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=60,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>2)&0xfbffffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<25);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>2)&0xffdfbdf7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<25);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>2)&0xffdebf7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<25);
            y=p[a]^(p[a]<<8)^((p[b]>>2)&0xdffff3ffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<25);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt2(uint s) : base(s) { }
    public Sfmt2(uint[]init_key) : base(init_key) { }
}

class Sfmt3 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:28-8-3-3-5:afffdffb-ffffdfbf-fbffdf77-7d7cfef7";
    } }

    static uint[]ParityData=
    { 0x20000001U,0x8ed2d92aU,0xefc5d057U,0xa6e061d3U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=112,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0x7d7cfef7U);
            p[a+3]=y^(p[d+3]<<8);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xfbffdf77U);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<8);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xffffdfbfU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<8);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xafffdffbU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<8);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt3(uint s) : base(s) { }
    public Sfmt3(uint[]init_key) : base(init_key) { }
}

class Sfmt4 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:10-17-3-13-3:bffdefff-ffaffeff-9f3ebfce-bf9fffdf";
    } }

    static uint[]ParityData=
    { 0xa0000001U,0xd3bdda16U,0x4140113fU,0xd458c634U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=40,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0xbf9fffdfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0x9f3ebfceU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0xffaffeffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xbffdefffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt4(uint s) : base(s) { }
    public Sfmt4(uint[]init_key) : base(init_key) { }
}

class Sfmt5 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:8-7-3-19-1:bffffffb-6f9ffbff-7f9fe7f7-bfeffffb";
    } }

    static uint[]ParityData=
    { 0x40000001U,0x4e4b2758U,0xb998e05aU,0xc4f1b268U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=32,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>19)&0xbfeffffbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>19)&0x7f9fe7f7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>19)&0x6f9ffbffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>19)&0xbffffffbU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt5(uint s) : base(s) { }
    public Sfmt5(uint[]init_key) : base(init_key) { }
}

class Sfmt6 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:13-18-1-21-1:e777f7fc-f7d7bf7d-edff7f5f-ffbfff7f";
    } }

    static uint[]ParityData=
    { 0x40000001U,0x7df3317aU,0xbbfeb4c7U,0x13a23b1dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=52,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>21)&0xffbfff7fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>21)&0xedff7f5fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>21)&0xf7d7bf7dU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>21)&0xe777f7fcU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt6(uint s) : base(s) { }
    public Sfmt6(uint[]init_key) : base(init_key) { }
}

class Sfmt7 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:14-6-3-3-5:7fdff3fb-57dfffdb-fe9ffddf-fefdae7f";
    } }

    static uint[]ParityData=
    { 0x42000001U,0xeb34cfceU,0x3eab62b1U,0x95b6f6ebU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=56,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xfefdae7fU);
            p[a+3]=y^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xfe9ffddfU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0x57dfffdbU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0x7fdff3fbU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt7(uint s) : base(s) { }
    public Sfmt7(uint[]init_key) : base(init_key) { }
}

class Sfmt8 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:23-11-7-6-1:ffbfbe7f-ffbfdf6d-bfbffdfd-fffffffd";
    } }

    static uint[]ParityData=
    { 0x60000001U,0x045bc889U,0x7b26b276U,0xf4e713f6U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=92,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>6)&0xfffffffdU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>6)&0xbfbffdfdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>6)&0xffbfdf6dU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^((p[b]>>6)&0xffbfbe7fU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt8(uint s) : base(s) { }
    public Sfmt8(uint[]init_key) : base(init_key) { }
}

class Sfmt9 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:16-16-3-11-3:fdffff4f-fff7fbff-ee7ffdff-dfbbfdff";
    } }

    static uint[]ParityData=
    { 0xc0000001U,0xeb6e2a53U,0x04550962U,0xe0c0375fU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=64,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xdfbbfdffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<16);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xee7ffdffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<16);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xfff7fbffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<16);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xfdffff4fU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<16);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt9(uint s) : base(s) { }
    public Sfmt9(uint[]init_key) : base(init_key) { }
}

class Sfmt10 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:28-5-3-11-5:f8fefff7-dfffffff-7fffffff-fffdfbf7";
    } }

    static uint[]ParityData=
    { 0xa0000001U,0xe4616943U,0x0a9b362cU,0xe8730649U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=112,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xfffdfbf7U);
            p[a+3]=y^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0x7fffffffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xdfffffffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xf8fefff7U);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt10(uint s) : base(s) { }
    public Sfmt10(uint[]init_key) : base(init_key) { }
}

class Sfmt11 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:12-17-5-5-3:ffffffff-bdffffff-e7fffffe-f3b7f7ef";
    } }

    static uint[]ParityData=
    { 0xa0000001U,0xe4d017d4U,0xe32206c7U,0xe65fe0eeU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=48,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>5)&0xf3b7f7efU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>5)&0xe7fffffeU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>5)&0xbdffffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^((p[b]>>5)&0xffffffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt11(uint s) : base(s) { }
    public Sfmt11(uint[]init_key) : base(init_key) { }
}

class Sfmt12 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:13-13-5-12-3:3ff7ff7f-ffffdfdf-ffbdbf7f-ffffbeff";
    } }

    static uint[]ParityData=
    { 0x90000001U,0x655f358eU,0x996adc07U,0x9ffd9669U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=52,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>12)&0xffffbeffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>12)&0xffbdbf7fU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>12)&0xffffdfdfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^((p[b]>>12)&0x3ff7ff7fU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt12(uint s) : base(s) { }
    public Sfmt12(uint[]init_key) : base(init_key) { }
}

class Sfmt13 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:18-13-3-17-7:bdf7ffff-fbdfbfff-7fdffb3f-ffbe6bef";
    } }

    static uint[]ParityData=
    { 0x20000001U,0xb081cfbeU,0xb3d5e047U,0x100e4768U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=72,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>17)&0xffbe6befU);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>17)&0x7fdffb3fU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>17)&0xfbdfbfffU);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>17)&0xbdf7ffffU);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt13(uint s) : base(s) { }
    public Sfmt13(uint[]init_key) : base(init_key) { }
}

class Sfmt14 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:11-21-3-6-1:fffffea7-fffdff3a-bfffffcf-dff5ffed";
    } }

    static uint[]ParityData=
    { 0xa0000001U,0x9405b85dU,0xc60478f2U,0xac65a61dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=44,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>6)&0xdff5ffedU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>6)&0xbfffffcfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>6)&0xfffdff3aU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>6)&0xfffffea7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt14(uint s) : base(s) { }
    public Sfmt14(uint[]init_key) : base(init_key) { }
}

class Sfmt15 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:1-12-1-7-1:ffbfff7b-fabf7ffb-ebfffefd-55fdfffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x324cb2feU,0x442f545cU,0x69f16b2bU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>7)&0x55fdfffeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>7)&0xebfffefdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>7)&0xfabf7ffbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<8)^((p[b]>>7)&0xffbfff7bU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt15(uint s) : base(s) { }
    public Sfmt15(uint[]init_key) : base(init_key) { }
}

class Sfmt16 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:16-18-5-7-3:dfbfffff-fb7e5fff-fffbdfff-dffbbfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x92040000U,0x6265f31aU,0x68abb978U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=64,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>7)&0xdffbbfffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<18);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>7)&0xfffbdfffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<18);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>7)&0xfb7e5fffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<18);
            y=p[a]^((p[b]>>7)&0xdfbfffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt16(uint s) : base(s) { }
    public Sfmt16(uint[]init_key) : base(init_key) { }
}

class Sfmt17 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:13-13-5-4-3:bf7febad-ff3ff756-fafaf6f6-fffffffc";
    } }

    static uint[]ParityData=
    { 0x28000001U,0xf2e5468cU,0x7b320d81U,0xd79d5d0dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=52,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>4)&0xfffffffcU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>4)&0xfafaf6f6U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>4)&0xff3ff756U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^((p[b]>>4)&0xbf7febadU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt17(uint s) : base(s) { }
    public Sfmt17(uint[]init_key) : base(init_key) { }
}

class Sfmt18 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:4-11-1-3-3:f7efdbfb-f7fffffb-fffefe7f-f7eb7fef";
    } }

    static uint[]ParityData=
    { 0x80000001U,0x9026447eU,0x1f279907U,0x070b4438U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=16,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>3)&0xf7eb7fefU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>3)&0xfffefe7fU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>3)&0xf7fffffbU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<8)^((p[b]>>3)&0xf7efdbfbU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt18(uint s) : base(s) { }
    public Sfmt18(uint[]init_key) : base(init_key) { }
}

class Sfmt19 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:32-3-3-11-3:ffffeffd-ffffeff7-ffffffef-ffdfffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x3725b98fU,0xd6e1adebU,0xdfbc6de4U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=128,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xffdfffffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xffffffefU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xffffeff7U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xffffeffdU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt19(uint s) : base(s) { }
    public Sfmt19(uint[]init_key) : base(init_key) { }
}

class Sfmt20 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:9-5-3-26-1:b9ffffdf-f9fdff7f-fffebffe-b6ff7ffd";
    } }

    static uint[]ParityData=
    { 0x10000001U,0xbc129652U,0xb4c6341bU,0x13cb9597U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=36,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>26)&0xb6ff7ffdU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>26)&0xfffebffeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>26)&0xf9fdff7fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>26)&0xb9ffffdfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt20(uint s) : base(s) { }
    public Sfmt20(uint[]init_key) : base(init_key) { }
}

class Sfmt21 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:32-3-3-3-5:fffffeff-fffb9d7f-ffdb9ff7-bff9fff7";
    } }

    static uint[]ParityData=
    { 0x60000001U,0x0623be05U,0x4730c7b7U,0xe4dcb68eU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=128,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>3)&0xbff9fff7U);
            p[a+3]=y^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>3)&0xffdb9ff7U);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>3)&0xfffb9d7fU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>3)&0xfffffeffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt21(uint s) : base(s) { }
    public Sfmt21(uint[]init_key) : base(init_key) { }
}

class Sfmt22 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:32-21-3-7-1:ff3feefd-ffffecff-fffffcfd-fffbadfd";
    } }

    static uint[]ParityData=
    { 0x70000001U,0xb4dc9c74U,0xfa71d735U,0x2b9421bdU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=128,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>7)&0xfffbadfdU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>7)&0xfffffcfdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>7)&0xffffecffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>7)&0xff3feefdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt22(uint s) : base(s) { }
    public Sfmt22(uint[]init_key) : base(init_key) { }
}

class Sfmt23 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:13-22-1-9-3:ffffebfb-7fffbb7f-cbddfffb-fff7ff7f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x179503c2U,0x84579cd5U,0x8bcf2f27U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=52,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>9)&0xfff7ff7fU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>9)&0xcbddfffbU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>9)&0x7fffbb7fU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>9)&0xffffebfbU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt23(uint s) : base(s) { }
    public Sfmt23(uint[]init_key) : base(init_key) { }
}

class Sfmt24 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:27-11-5-8-3:d73d23f7-ef7fffff-eeffffdf-fffbf6cf";
    } }

    static uint[]ParityData=
    { 0x40000001U,0xbec29ed7U,0x722046bcU,0x7d6ac005U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=108,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>8)&0xfffbf6cfU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>8)&0xeeffffdfU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>8)&0xef7fffffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>8)&0xd73d23f7U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt24(uint s) : base(s) { }
    public Sfmt24(uint[]init_key) : base(init_key) { }
}

class Sfmt25 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:19-26-1-19-7:efbfbff7-fb7fffff-feeffdfb-7fbfebf9";
    } }

    static uint[]ParityData=
    { 0xb0000001U,0xc49c2158U,0xdd1db4e7U,0x0da08972U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=76,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>19)&0x7fbfebf9U);
            p[a+3]=y^(p[d+3]<<26);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>19)&0xfeeffdfbU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<26);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>19)&0xfb7fffffU);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<26);
            y=p[a]^(p[a]<<8)^((p[b]>>19)&0xefbfbff7U);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<26);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt25(uint s) : base(s) { }
    public Sfmt25(uint[]init_key) : base(init_key) { }
}

class Sfmt26 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:12-29-1-1-1:fff7dffd-ffdd7fbd-ffffbff7-ffff9dff";
    } }

    static uint[]ParityData=
    { 0xe0000001U,0x8ecaba1bU,0x4a61645bU,0x6aac5023U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=48,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xffff9dffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<29);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xffffbff7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<29);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0xffdd7fbdU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<29);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xfff7dffdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<29);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt26(uint s) : base(s) { }
    public Sfmt26(uint[]init_key) : base(init_key) { }
}

class Sfmt27 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:25-22-5-19-3:efffffef-fbdfb3ff-fbf7f7fd-fef7fffb";
    } }

    static uint[]ParityData=
    { 0x80000001U,0xacaa212fU,0xaa5340c9U,0x5ca836d2U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=100,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>19)&0xfef7fffbU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<22);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>19)&0xfbf7f7fdU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<22);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>19)&0xfbdfb3ffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<22);
            y=p[a]^((p[b]>>19)&0xefffffefU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt27(uint s) : base(s) { }
    public Sfmt27(uint[]init_key) : base(init_key) { }
}

class Sfmt28 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:24-2-3-7-1:ef8ffffa-fffbfff8-f7ffbfe9-77ffbffd";
    } }

    static uint[]ParityData=
    { 0x20000001U,0x8f3c8ae4U,0xa3cf01c6U,0xa91d27ddU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=96,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>7)&0x77ffbffdU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<2);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>7)&0xf7ffbfe9U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<2);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>7)&0xfffbfff8U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<2);
            y=p[a]^(p[a]<<24)^((p[b]>>7)&0xef8ffffaU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<2);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt28(uint s) : base(s) { }
    public Sfmt28(uint[]init_key) : base(init_key) { }
}

class Sfmt29 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:4-14-5-9-3:7bfffff7-fff7fff3-ff9fbf9e-fffdafff";
    } }

    static uint[]ParityData=
    { 0xc0000001U,0x93fcf151U,0x739a3cf7U,0x72b647f3U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=16,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>9)&0xfffdafffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>9)&0xff9fbf9eU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>9)&0xfff7fff3U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<14);
            y=p[a]^((p[b]>>9)&0x7bfffff7U);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt29(uint s) : base(s) { }
    public Sfmt29(uint[]init_key) : base(init_key) { }
}

class Sfmt30 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:21-20-1-19-3:ffb7fffd-9fefedfd-9edb6ffb-bedeb7ff";
    } }

    static uint[]ParityData=
    { 0x40000001U,0x9ed70b6bU,0x661e1ca7U,0xfd968985U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=84,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>19)&0xbedeb7ffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>19)&0x9edb6ffbU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>19)&0x9fefedfdU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>19)&0xffb7fffdU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt30(uint s) : base(s) { }
    public Sfmt30(uint[]init_key) : base(init_key) { }
}

class Sfmt31 : Sfmt
{
    public override string IdString { get {
        return"SFMT-4253:31-15-5-14-3:efbce7ff-feb7f77f-fff3ffbf-bfffb75f";
    } }

    static uint[]ParityData=
    { 0x48000001U,0x836a277aU,0xc4833eb6U,0x22b0dc59U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=124,c=128,d=132; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>14)&0xbfffb75fU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<15);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>14)&0xfff3ffbfU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<15);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>14)&0xfeb7f77fU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<15);
            y=p[a]^((p[b]>>14)&0xefbce7ffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    public Sfmt31(uint s) : base(s) { }
    public Sfmt31(uint[]init_key) : base(init_key) { }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt1 (unchecked((uint) -1)),
        new Sfmt2 (unchecked((uint) -2)),
        new Sfmt3 (unchecked((uint) -3)),
        new Sfmt4 (unchecked((uint) -4)),
        new Sfmt5 (unchecked((uint) -5)),
        new Sfmt6 (unchecked((uint) -6)),
        new Sfmt7 (unchecked((uint) -7)),
        new Sfmt8 (unchecked((uint) -8)),
        new Sfmt9 (unchecked((uint) -9)),
        new Sfmt10(unchecked((uint)-10)),
        new Sfmt11(unchecked((uint)-11)),
        new Sfmt12(unchecked((uint)-12)),
        new Sfmt13(unchecked((uint)-13)),
        new Sfmt14(unchecked((uint)-14)),
        new Sfmt15(unchecked((uint)-15)),
        new Sfmt16(unchecked((uint)-16)),
        new Sfmt17(unchecked((uint)-17)),
        new Sfmt18(unchecked((uint)-18)),
        new Sfmt19(unchecked((uint)-19)),
        new Sfmt20(unchecked((uint)-20)),
        new Sfmt21(unchecked((uint)-21)),
        new Sfmt22(unchecked((uint)-22)),
        new Sfmt23(unchecked((uint)-23)),
        new Sfmt24(unchecked((uint)-24)),
        new Sfmt25(unchecked((uint)-25)),
        new Sfmt26(unchecked((uint)-26)),
        new Sfmt27(unchecked((uint)-27)),
        new Sfmt28(unchecked((uint)-28)),
        new Sfmt29(unchecked((uint)-29)),
        new Sfmt30(unchecked((uint)-30)),
        new Sfmt31(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

