/*
Sfmt607.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[20]; /* ԃe[u */

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x5986f054U };

    protected virtual uint[]GetParity() { return ParityData; }

    public virtual string IdString { get {
        return"SFMT-607:2-15-3-13-3:fdff37ff-ef7f3f7d-ff777b7d-7ff7fb2f";
    } }

    public virtual void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>13)&0x7ff7fb2fU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<15);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>13)&0xff777b7dU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<15);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>13)&0xef7f3f7dU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<15);
            y=p[a]^(p[a]<<24)^((p[b]>>13)&0xfdff37ffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=20; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<20;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<20;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>20) c=key_len+1; else c=20;
            r=x[0]^x[8]^x[19]; r=(r^(r>>27))*1664525;
            x[8]+=r; r+=key_len; x[11]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+8)%20]^x[(i+19)%20];
                r=(r^(r>>27))*1664525; x[(i+8)%20]+=r;
                r+=init_key[j]+i; x[(i+11)%20]+=r;
                x[i]=r; i=(i+1)%20;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+8)%20]^x[(i+19)%20];
                r=(r^(r>>27))*1664525; x[(i+8)%20]+=r; r+=i;
                x[(i+11)%20]+=r; x[i]=r; i=(i+1)%20;
            }
            for (j=0;j<20;j++) {
                r=x[i]+x[(i+8)%20]+x[(i+19)%20];
                r=(r^(r>>27))*1566083941; x[(i+8)%20]^=r;
                r-=i; x[(i+11)%20]^=r; x[i]=r; i=(i+1)%20;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==20) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt1 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-19-1-13-1:ffbfffbf-cdffffff-effbffed-fef8fbdc";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x30b388afU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>13)&0xfef8fbdcU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>13)&0xeffbffedU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>13)&0xcdffffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>13)&0xffbfffbfU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt1(uint s) : base(s) { }
    public Sfmt1(uint[]init_key) : base(init_key) { }
}

class Sfmt2 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-13-3-11-5:df7fffff-f7ff77ff-fffff2ff-ffff473f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xb5a64116U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xffff473fU);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xfffff2ffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xf7ff77ffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xdf7fffffU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt2(uint s) : base(s) { }
    public Sfmt2(uint[]init_key) : base(init_key) { }
}

class Sfmt3 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:3-11-3-21-1:6fff7ffe-f5fffffe-bffffffe-afdfffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x10000000U,0x6f6fec6aU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>21)&0xafdfffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>21)&0xbffffffeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>21)&0xf5fffffeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>21)&0x6fff7ffeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt3(uint s) : base(s) { }
    public Sfmt3(uint[]init_key) : base(init_key) { }
}

class Sfmt4 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-15-1-3-1:ff77fff7-fd77ffff-fffffdcf-fffffffa";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x20000000U,0xd63bbe55U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>3)&0xfffffffaU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<15);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>3)&0xfffffdcfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<15);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>3)&0xfd77ffffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<15);
            y=p[a]^(p[a]<<8)^((p[b]>>3)&0xff77fff7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt4(uint s) : base(s) { }
    public Sfmt4(uint[]init_key) : base(init_key) { }
}

class Sfmt5 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-7-3-2-1:bedf9cff-dfe6dfff-fdfffffa-dfff7efb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0xa52af51dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>2)&0xdfff7efbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>2)&0xfdfffffaU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>2)&0xdfe6dfffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>2)&0xbedf9cffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt5(uint s) : base(s) { }
    public Sfmt5(uint[]init_key) : base(init_key) { }
}

class Sfmt6 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-14-1-1-1:ffefffff-7e6ffa77-fff7fffa-fbbffffb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x57810851U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>1)&0xfbbffffbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>1)&0xfff7fffaU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>1)&0x7e6ffa77U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<8)^((p[b]>>1)&0xffefffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt6(uint s) : base(s) { }
    public Sfmt6(uint[]init_key) : base(init_key) { }
}

class Sfmt7 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-14-1-11-1:7bfffbff-fba7ffbf-f7fffe3f-f36fffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x170c7993U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>11)&0xf36fffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>11)&0xf7fffe3fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>11)&0xfba7ffbfU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<8)^((p[b]>>11)&0x7bfffbffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt7(uint s) : base(s) { }
    public Sfmt7(uint[]init_key) : base(init_key) { }
}

class Sfmt8 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-14-5-3-1:ffe7ffff-ff6fefff-7f3fffff-ff7feffb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0xf4112310U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>3)&0xff7feffbU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>3)&0x7f3fffffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>3)&0xff6fefffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^((p[b]>>3)&0xffe7ffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt8(uint s) : base(s) { }
    public Sfmt8(uint[]init_key) : base(init_key) { }
}

class Sfmt9 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-5-3-6-3:d3ddebfb-ffdfffdf-ffbf9bff-efefbfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x02000000U,0x67e80003U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>6)&0xefefbfffU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>6)&0xffbf9bffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>6)&0xffdfffdfU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>6)&0xd3ddebfbU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt9(uint s) : base(s) { }
    public Sfmt9(uint[]init_key) : base(init_key) { }
}

class Sfmt10 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:3-13-1-3-3:7fffd6be-ffbefdfc-f7ff73f5-37fff7fb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0xcd8ababaU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>3)&0x37fff7fbU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>3)&0xf7ff73f5U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>3)&0xffbefdfcU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>3)&0x7fffd6beU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt10(uint s) : base(s) { }
    public Sfmt10(uint[]init_key) : base(init_key) { }
}

class Sfmt11 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-12-7-9-1:feffffde-fe8fbfb7-63effffd-7fe7b3f5";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x694481ddU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>9)&0x7fe7b3f5U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>9)&0x63effffdU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>9)&0xfe8fbfb7U);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^((p[b]>>9)&0xfeffffdeU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt11(uint s) : base(s) { }
    public Sfmt11(uint[]init_key) : base(init_key) { }
}

class Sfmt12 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-13-7-5-1:fffff9b7-bfebffdb-e7dfeefe-f3ff3eff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x6e1c11beU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>5)&0xf3ff3effU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>5)&0xe7dfeefeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>5)&0xbfebffdbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^((p[b]>>5)&0xfffff9b7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt12(uint s) : base(s) { }
    public Sfmt12(uint[]init_key) : base(init_key) { }
}

class Sfmt13 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:3-6-7-1-1:feffbff7-fffdd7ff-7ffffdff-fdffffff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x047cd258U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>1)&0xfdffffffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>1)&0x7ffffdffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>1)&0xfffdd7ffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^((p[b]>>1)&0xfeffbff7U);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt13(uint s) : base(s) { }
    public Sfmt13(uint[]init_key) : base(init_key) { }
}

class Sfmt14 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-23-1-20-1:f5ffbfff-bffcfffe-ffbffefe-7fffbeef";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xde196133U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>20)&0x7fffbeefU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<23);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>20)&0xffbffefeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<23);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>20)&0xbffcfffeU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<23);
            y=p[a]^(p[a]<<8)^((p[b]>>20)&0xf5ffbfffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<23);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt14(uint s) : base(s) { }
    public Sfmt14(uint[]init_key) : base(init_key) { }
}

class Sfmt15 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-13-1-16-3:fffffbbf-fffdffef-efb97fff-df7fffef";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x946dbc1cU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>16)&0xdf7fffefU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>16)&0xefb97fffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>16)&0xfffdffefU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>16)&0xfffffbbfU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt15(uint s) : base(s) { }
    public Sfmt15(uint[]init_key) : base(init_key) { }
}

class Sfmt16 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-17-3-22-5:dffffafe-dffffeff-fd77ffdf-fbfffffb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xa7c70cc8U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>22)&0xfbfffffbU);
            p[a+3]=y^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>22)&0xfd77ffdfU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>22)&0xdffffeffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>22)&0xdffffafeU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt16(uint s) : base(s) { }
    public Sfmt16(uint[]init_key) : base(init_key) { }
}

class Sfmt17 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-7-3-21-3:bffddfef-ffffffd7-3ffffff7-fff5effb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0xe7aab0e7U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>21)&0xfff5effbU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>21)&0x3ffffff7U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>21)&0xffffffd7U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>21)&0xbffddfefU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt17(uint s) : base(s) { }
    public Sfmt17(uint[]init_key) : base(init_key) { }
}

class Sfmt18 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-5-3-15-5:ffffdf7f-bfffed97-ffeadcbf-f7ffbefb";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x7aa354e4U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>15)&0xf7ffbefbU);
            p[a+3]=y^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>15)&0xffeadcbfU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>15)&0xbfffed97U);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>15)&0xffffdf7fU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt18(uint s) : base(s) { }
    public Sfmt18(uint[]init_key) : base(init_key) { }
}

class Sfmt19 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-10-3-23-1:ffebccfd-affffffd-f777bdff-af7effff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0xc824d8c1U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>23)&0xaf7effffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>23)&0xf777bdffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>23)&0xaffffffdU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>23)&0xffebccfdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt19(uint s) : base(s) { }
    public Sfmt19(uint[]init_key) : base(init_key) { }
}

class Sfmt20 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-4-3-1-1:fe9fffef-ffbffeff-be57bdff-fefb3f5f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x41129a62U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>1)&0xfefb3f5fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<4);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>1)&0xbe57bdffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<4);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>1)&0xffbffeffU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<4);
            y=p[a]^(p[a]<<24)^((p[b]>>1)&0xfe9fffefU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<4);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt20(uint s) : base(s) { }
    public Sfmt20(uint[]init_key) : base(init_key) { }
}

class Sfmt21 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-5-3-18-5:fcbeffcf-5bfebb7f-fff5efff-efb5eff9";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x4925021aU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>18)&0xefb5eff9U);
            p[a+3]=y^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>18)&0xfff5efffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>18)&0x5bfebb7fU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>18)&0xfcbeffcfU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt21(uint s) : base(s) { }
    public Sfmt21(uint[]init_key) : base(init_key) { }
}

class Sfmt22 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-3-3-2-3:ffffffff-ffffeef7-bff6ff73-ffe7f7d7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x737556b0U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>2)&0xffe7f7d7U);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>2)&0xbff6ff73U);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>2)&0xffffeef7U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>2)&0xffffffffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt22(uint s) : base(s) { }
    public Sfmt22(uint[]init_key) : base(init_key) { }
}

class Sfmt23 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:3-11-5-4-1:7fdfffff-7cddd7fa-febfdeee-ffbffef7";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xb4be184dU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>4)&0xffbffef7U);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>4)&0xfebfdeeeU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>4)&0x7cddd7faU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^((p[b]>>4)&0x7fdfffffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt23(uint s) : base(s) { }
    public Sfmt23(uint[]init_key) : base(init_key) { }
}

class Sfmt24 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-21-5-4-1:ffbbf77f-ff7ffbfb-bffff7f7-efecdfff";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x04000000U,0xf361b11fU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>4)&0xefecdfffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>4)&0xbffff7f7U);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>4)&0xff7ffbfbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^((p[b]>>4)&0xffbbf77fU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt24(uint s) : base(s) { }
    public Sfmt24(uint[]init_key) : base(init_key) { }
}

class Sfmt25 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-13-3-18-7:dfbf5fff-cffd7eff-ffbe3fff-fdbfff9f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0xd28269a7U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>18)&0xfdbfff9fU);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>18)&0xffbe3fffU);
            p[a+2]=y^(p[c+3]>>24)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>18)&0xcffd7effU);
            p[a+1]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>18)&0xdfbf5fffU);
            p[a]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt25(uint s) : base(s) { }
    public Sfmt25(uint[]init_key) : base(init_key) { }
}

class Sfmt26 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:3-11-5-12-3:ebffefff-fbfffaff-f7fffeff-7ffefffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x40000000U,0x39660c35U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>12)&0x7ffefffeU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>12)&0xf7fffeffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>12)&0xfbfffaffU);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>12)&0xebffefffU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt26(uint s) : base(s) { }
    public Sfmt26(uint[]init_key) : base(init_key) { }
}

class Sfmt27 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-11-5-6-3:ffffffdd-dff7bdf7-f3fff1ff-ffff7ffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x18ceeb85U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>6)&0xffff7ffeU);
            p[a+3]=y^(p[c+3]>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>6)&0xf3fff1ffU);
            p[a+2]=y^((p[c+2]>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>6)&0xdff7bdf7U);
            p[a+1]=y^((p[c+1]>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>6)&0xffffffddU);
            p[a]=y^((p[c]>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt27(uint s) : base(s) { }
    public Sfmt27(uint[]init_key) : base(init_key) { }
}

class Sfmt28 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:2-21-3-11-5:ffff7ebf-fffd7fff-dffdfdff-ffa57bdf";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x80000000U,0x41d828efU };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=8,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>8)^((p[b+3]>>11)&0xffa57bdfU);
            p[a+3]=y^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+2]>>11)&0xdffdfdffU);
            p[a+2]=y^(p[c+3]>>8)^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>8)^((p[b+1]>>11)&0xfffd7fffU);
            p[a+1]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>11)&0xffff7ebfU);
            p[a]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt28(uint s) : base(s) { }
    public Sfmt28(uint[]init_key) : base(init_key) { }
}

class Sfmt29 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:3-20-7-7-1:beffbffb-bffffffb-ffffefff-eefbef3f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x2a5c3390U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=12,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>7)&0xeefbef3fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>7)&0xffffefffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>7)&0xbffffffbU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^((p[b]>>7)&0xbeffbffbU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt29(uint s) : base(s) { }
    public Sfmt29(uint[]init_key) : base(init_key) { }
}

class Sfmt30 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-18-1-7-1:f7ffb5fd-b76ff7fd-fdfff7df-f9dffffe";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xd99b3c70U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>24)^((p[b+3]>>7)&0xf9dffffeU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+2]>>7)&0xfdfff7dfU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>24)^((p[b+1]>>7)&0xb76ff7fdU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>7)&0xf7ffb5fdU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt30(uint s) : base(s) { }
    public Sfmt30(uint[]init_key) : base(init_key) { }
}

class Sfmt31 : Sfmt
{
    public override string IdString { get {
        return"SFMT-607:1-21-5-19-1:bfff7eff-7fffbfef-fffbff7f-effeff6f";
    } }

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0x85b22d17U };

    protected override uint[]GetParity() { return ParityData; }

    public override void gen_rand_all() {
        int a=0,b=4,c=12,d=16; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>24)^((p[b+3]>>19)&0xeffeff6fU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>24)^((p[b+2]>>19)&0xfffbff7fU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>19)&0x7fffbfefU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^((p[b]>>19)&0xbfff7effU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    public Sfmt31(uint s) : base(s) { }
    public Sfmt31(uint[]init_key) : base(init_key) { }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt1 (unchecked((uint) -1)),
        new Sfmt2 (unchecked((uint) -2)),
        new Sfmt3 (unchecked((uint) -3)),
        new Sfmt4 (unchecked((uint) -4)),
        new Sfmt5 (unchecked((uint) -5)),
        new Sfmt6 (unchecked((uint) -6)),
        new Sfmt7 (unchecked((uint) -7)),
        new Sfmt8 (unchecked((uint) -8)),
        new Sfmt9 (unchecked((uint) -9)),
        new Sfmt10(unchecked((uint)-10)),
        new Sfmt11(unchecked((uint)-11)),
        new Sfmt12(unchecked((uint)-12)),
        new Sfmt13(unchecked((uint)-13)),
        new Sfmt14(unchecked((uint)-14)),
        new Sfmt15(unchecked((uint)-15)),
        new Sfmt16(unchecked((uint)-16)),
        new Sfmt17(unchecked((uint)-17)),
        new Sfmt18(unchecked((uint)-18)),
        new Sfmt19(unchecked((uint)-19)),
        new Sfmt20(unchecked((uint)-20)),
        new Sfmt21(unchecked((uint)-21)),
        new Sfmt22(unchecked((uint)-22)),
        new Sfmt23(unchecked((uint)-23)),
        new Sfmt24(unchecked((uint)-24)),
        new Sfmt25(unchecked((uint)-25)),
        new Sfmt26(unchecked((uint)-26)),
        new Sfmt27(unchecked((uint)-27)),
        new Sfmt28(unchecked((uint)-28)),
        new Sfmt29(unchecked((uint)-29)),
        new Sfmt30(unchecked((uint)-30)),
        new Sfmt31(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

