/*
Sfmt86243.cs Cu
coded by isaku@pb4.so-net.ne.jp
*/

using System;

class Sfmt
{
    int    index;
    int    coin_bits; /* NextBit ł̎c̃rbg */
    uint   coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    uint   byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    uint   bse; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */
    protected uint[]x=new uint[2696]; /* ԃe[u */

    static uint[]ParityData=
    { 0x00000001U,0x00000000U,0x00000000U,0xe9528d85U };

    protected uint[]GetParity() { return ParityData; }

    public string IdString { get {
        return"SFMT-86243:366-6-7-19-1:fdbffbff-bff7ff3f-fd77efff-bf9ff3ff";
    } }

    public void gen_rand_all() {
        int a=0,b=1464,c=2688,d=2692; uint y; uint[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>8)^((p[b+3]>>19)&0xbf9ff3ffU);
            p[a+3]=y^(p[c+3]>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>8)^((p[b+2]>>19)&0xfd77efffU);
            p[a+2]=y^((p[c+2]>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>19)&0xbff7ff3fU);
            p[a+1]=y^((p[c+1]>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^((p[b]>>19)&0xfdbffbffU);
            p[a]=y^((p[c]>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==2696) b=0;
        } while (a!=2696);
    }

    void period_certification() {
        uint work,inner=0; int i,j; uint[] parity=GetParity();

        index=2696; range=0; normal_sw=0; coin_bits=0; byte_pos=0;
        for (i=0;i<4;i++) inner^=x[i]&parity[i];
        for (i=16;i>0;i>>=1) inner^=inner>>i;
        inner&=1;
        if (inner==1) return;
        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)
         if ((work&parity[i])!=0) { x[i]^=work; return; }
    }

    /* ̎ s ɂ鏉 */
    public void InitMt(uint s) {
        unchecked {
            x[0]=s;
            for (uint p=1;p<2696;p++)
                x[p]=s=1812433253*(s^(s>>30))+p;
            period_certification();
        }
    }

    public Sfmt(uint s) { InitMt(s); }

    /* z init_key ɂ鏉 */
    public void InitMtEx(uint[]init_key) {
        uint r,i,j,c,key_len=(uint)init_key.Length;

        unchecked {
            for (i=0;i<2696;i++) x[i]=0x8b8b8b8b;
            if (key_len+1>2696) c=key_len+1; else c=2696;
            r=x[0]^x[1342]^x[2695]; r=(r^(r>>27))*1664525;
            x[1342]+=r; r+=key_len; x[1353]+=r; x[0]=r; c--;
            for (i=1,j=0;j<c&&j<key_len;j++) {
                r=x[i]^x[(i+1342)%2696]^x[(i+2695)%2696];
                r=(r^(r>>27))*1664525; x[(i+1342)%2696]+=r;
                r+=init_key[j]+i; x[(i+1353)%2696]+=r;
                x[i]=r; i=(i+1)%2696;
            }
            for (;j<c;j++) {
                r=x[i]^x[(i+1342)%2696]^x[(i+2695)%2696];
                r=(r^(r>>27))*1664525; x[(i+1342)%2696]+=r; r+=i;
                x[(i+1353)%2696]+=r; x[i]=r; i=(i+1)%2696;
            }
            for (j=0;j<2696;j++) {
                r=x[i]+x[(i+1342)%2696]+x[(i+2695)%2696];
                r=(r^(r>>27))*1566083941; x[(i+1342)%2696]^=r;
                r-=i; x[(i+1353)%2696]^=r; x[i]=r; i=(i+1)%2696;
            }
            period_certification();
        }
    }

    public Sfmt(uint[]init_key) { InitMtEx(init_key); }

    /* 32rbgȂ̗ */
    public uint NextMt() {
        if (index==2696) { gen_rand_all(); index=0; }
        return x[index++];
    }

    /* Oȏ n ̐ */
    public int NextInt(int n)
    { return(int)(n*(1.0/4294967296.0)*NextMt()); }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        uint z=NextMt()>>11,y=NextMt();
        return(y*2097152.0+z)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    public int NextIntEx(int range_) {
        uint y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            bse=(uint)(range=range_);
            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;
        }
        for (;;) {
            y_=NextMt()>>1;
            if (y_<bse) return(int)(y_>>shift);
            base_=bse; shift_=shift; y_-=base_;
            remain_=(1U<<31)-base_;
            for (;remain_>=(uint)range_;remain_-=base_) {
                for (;base_>remain_;base_>>=1) shift_--;
                if (y_<base_) return(int)(y_>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,y;
        if (a>1) {
            t=Math.Sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        y=2*NextUnif()-1;
                    } while (X*X+y*y>1);
                    y/=X; X=t*y+a-1;
                } while (X<=0);
                u=(a-1)*Math.Log(X/(a-1))-t*y;
            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);
                } else {
                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);
                }
            } while (NextUnif()>=y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.Log(1-NextUnif()); }

    /* WKz(ő8.57) */
    public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.Sin(u); normal_sw=1;
            return t*Math.Cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public void NextUnitVect(out double[]v,int n) {
        int i; double r=0;
        v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.Sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public void NextBinormal(double r,out double a,out double b) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;
        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.Pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.Log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.Exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.Sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.Log(1-NextUnif())/(1-0.5*n);
        } while (Math.Exp(-b-c)>1-b);
        return a/Math.Sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }
}

class Sfmt_m
{
    static Sfmt[]z={
        new Sfmt(1),
        new Sfmt(unchecked((uint) -1)),
        new Sfmt(unchecked((uint) -2)),
        new Sfmt(unchecked((uint) -3)),
        new Sfmt(unchecked((uint) -4)),
        new Sfmt(unchecked((uint) -5)),
        new Sfmt(unchecked((uint) -6)),
        new Sfmt(unchecked((uint) -7)),
        new Sfmt(unchecked((uint) -8)),
        new Sfmt(unchecked((uint) -9)),
        new Sfmt(unchecked((uint)-10)),
        new Sfmt(unchecked((uint)-11)),
        new Sfmt(unchecked((uint)-12)),
        new Sfmt(unchecked((uint)-13)),
        new Sfmt(unchecked((uint)-14)),
        new Sfmt(unchecked((uint)-15)),
        new Sfmt(unchecked((uint)-16)),
        new Sfmt(unchecked((uint)-17)),
        new Sfmt(unchecked((uint)-18)),
        new Sfmt(unchecked((uint)-19)),
        new Sfmt(unchecked((uint)-20)),
        new Sfmt(unchecked((uint)-21)),
        new Sfmt(unchecked((uint)-22)),
        new Sfmt(unchecked((uint)-23)),
        new Sfmt(unchecked((uint)-24)),
        new Sfmt(unchecked((uint)-25)),
        new Sfmt(unchecked((uint)-26)),
        new Sfmt(unchecked((uint)-27)),
        new Sfmt(unchecked((uint)-28)),
        new Sfmt(unchecked((uint)-29)),
        new Sfmt(unchecked((uint)-30)),
        new Sfmt(unchecked((uint)-31))
    };

    public static string IdString_m(int i)
    { return z[i].IdString; }

    public static void InitMt_m(int i,uint s)
    { z[i].InitMt(s); }

    public static void InitMtEx_m(int i,uint[]k)
    { z[i].InitMtEx(k); }

    public static uint NextMt_m(int i)
    { return z[i].NextMt(); }

    public static int NextInt_m(int i,int n)
    { return z[i].NextInt(n); }

    public static int NextBit_m(int i)
    { return z[i].NextBit(); }

    public static int NextByte_m(int i)
    { return z[i].NextByte(); }

    public static double NextUnif_m(int i)
    { return z[i].NextUnif(); }

    public static int NextIntEx_m(int i,int r)
    { return z[i].NextIntEx(r); }

    public static double NextChisq_m(int i,double n)
    { return z[i].NextChisq(n); }

    public static double NextGamma_m(int i,double a)
    { return z[i].NextGamma(a); }

    public static int NextGeometric_m(int i,double p)
    { return z[i].NextGeometric(p); }

    public static double NextTriangle_m(int i)
    { return z[i].NextTriangle(); }

    public static double NextExp_m(int i)
    { return z[i].NextExp(); }

    public static double NextNormal_m(int i)
    { return z[i].NextNormal(); }

    public static void NextUnitVect_m(int i,out double[]v,int n)
    { z[i].NextUnitVect(out v,n); }

    public static int NextBinomial_m(int i,int n,double p)
    { return z[i].NextBinomial(n,p); }

    public static void NextBinormal_m(int i,double r,out double a,out double b)
    { z[i].NextBinormal(r,out a,out b); }

    public static double NextBeta_m(int i,double a,double b)
    { return z[i].NextBeta(a,b); }

    public static double NextPower_m(int i,double n)
    { return z[i].NextPower(n); }

    public static double NextLogistic_m(int i)
    { return z[i].NextLogistic(); }

    public static double NextCauchy_m(int i)
    { return z[i].NextCauchy(); }

    public static int NextPoisson_m(int i,double l)
    { return z[i].NextPoisson(l); }

    public static double NextFDist_m(int i,double n1,double n2)
    { return z[i].NextFDist(n1,n2); }

    public static double NextTDist_m(int i,double n)
    { return z[i].NextTDist(n); }

    public static double NextWeibull_m(int i,double a)
    { return z[i].NextWeibull(a); }

}

