/*
GenC.c:  ?????.csv t@C z-?????.h t@C쐬
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <direct.h>

enum { NumOfFiles=6,NumOfMacros=15,NumOfLines=32 };
long Mexp[]={607L,1279L,2281L,4253L,11213L,19937L};
long Data[NumOfFiles][NumOfLines][NumOfMacros];

/*
@16i̕longɕϊ鄠
@*/
long htol(char*p)
{
    static char tbl[]="0123456789abcdef"; long ret=0; int i,c;

    while ((c=*p++)!=0) {
        for (i=0;i<16&&tbl[i]!=c;i++) ;
        ret=ret*16+i;
    }
    return ret;
}

int main(void)
{
    static char buf[2048],fname[128];
    int file,line,macro; long*x,swap; FILE*fp; char*p;

    for (file=0;file<NumOfFiles;file++) {
        sprintf(fname,"%ld.csv",Mexp[file]);
        fp=fopen(fname,"r");
        if (fp==0) { printf("'%s'cannot open\n",fname); return 1;}
        if (fgets(buf,sizeof buf,fp)==0)
        { printf("'%s'is empty\n",fname); return 1; }
        for (line=0;line<NumOfLines;line++) {
            p=fgets(buf,sizeof buf,fp);
            if (p==0) {
                printf("'%s':%d unexpected EOF\n",fname,line);
                return 1;
            }
            p=strtok(buf,",\r\n");
            for (macro=0;macro<NumOfMacros;macro++) {
                if (p==0) {
                    printf("'%s':%d unexpected EOLN\n",fname,line);
                    return 1;
                }
                if (macro>=7&&macro<=14)
                    Data[file][line][macro]=htol(p);
                else
                    Data[file][line][macro]=atol(p);
                p=strtok(0,",\r\n");
            }
        }
        fclose(fp);
    }

    /* MEXP=1279 ̍ŏ̃CftHgŖ̂œւ */
    for (macro=0;macro<NumOfMacros;macro++) {
        swap=Data[1][0][macro];
        Data[1][0][macro]=Data[1][1][macro];
        Data[1][1][macro]=swap;
    }

    printf("OK\n");

    if (mkdir("..\\SfmtC")==0) printf("'..\\SfmtC'was created\n");
    for (file=0;file<NumOfFiles;file++) {
        x=Data[file][0];
        sprintf(fname,"..\\SfmtC\\z-%ld.h",Mexp[file]);
        fp=fopen(fname,"w");
        if (fp==0) { printf("'%s'cannot create\n",fname); return 1;}
        fprintf(fp,"/* MEXP:%ld */\n",Mexp[file]);
        fprintf(fp,"static uint32_t MtParity[][4]={\n");
        fprintf(fp," {0x%08lxUL,0x%08lxUL,0x%08lxUL,0x%08lxUL}\n\n",
                x[11],x[12],x[13],x[14]);
        for (line=1;line<NumOfLines;line++) {
            fprintf(fp,"#if MSEQ2 > %d\n",line);
            x=Data[file][line];
            fprintf(fp,
                ",{0x%08lxUL,0x%08lxUL,0x%08lxUL,0x%08lxUL}\n",
                x[11],x[12],x[13],x[14]);
            fprintf(fp,"#endif\n\n");
        }
        fprintf(fp,"};\n\n");
        for (line=0;line<NumOfLines;line++) {
            x=Data[file][line];
            if (line==1) fprintf(fp,"#define MSEQ2_OK\n\n");
            if (line) fprintf(fp,"#if MSEQ2 > %d\n",line);
            fprintf(fp,"#define SSE2_NAME mfs%02d_\n",line);
            fprintf(fp,"#define FUNC_NAME mfg%02d_\n",line);
            fprintf(fp,"#define POS1    %ld\n", x[2]);
            fprintf(fp,"#define SL1     %ld\n", x[3]);
            fprintf(fp,"#define SL2     %ld\n", x[4]);
            fprintf(fp,"#define SR1     %ld\n", x[5]);
            fprintf(fp,"#define SR2     %ld\n", x[6]);
            fprintf(fp,"#define MSK1    0x%08lxUL\n",x[7]);
            fprintf(fp,"#define MSK2    0x%08lxUL\n",x[8]);
            fprintf(fp,"#define MSK3    0x%08lxUL\n",x[9]);
            fprintf(fp,"#define MSK4    0x%08lxUL\n",x[10]);
            fprintf(fp,"#define ids%02d_ \\\n",line);
            fprintf(fp,"\"SFMT-%ld:%ld-%ld-%ld-%ld-%ld:"
                     "%08lx-%08lx-%08lx-%08lx\"\n",Mexp[file],
                     x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9],x[10]);
            fprintf(fp,"#include \"z-func.h\"\n");
            if (line) {
                fprintf(fp,"#else\n");
                fprintf(fp,"#define mfs%02d_ 0\n",line);
                fprintf(fp,"#define mfg%02d_ 0\n",line);
                fprintf(fp,"#define ids%02d_ 0\n",line);
                fprintf(fp,"#endif\n");
            }
            fprintf(fp,"\n");
        }
        fclose(fp);
        printf("'%s'was created\n",fname);
    }
    return 0;
}
