'
' Sfmt11213.vb Cu
' coded by isaku@pb4.so-net.ne.jp
' 

Class Sfmt

    Private index As Integer
    Private coin_bits As Integer ' NextBit ł̎c̃rbg
    Private coin_save As UInteger ' NextBit ł̒lێ
    Private byte_pos As Integer ' NextByte ŎgpoCg
    Private byte_save As UInteger ' NextByte ł̒lێ
    Private range As Integer ' NextIntEx őO͈̔
    Private bse As UInteger  ' NextIntEx őO̊l
    Private shift As Integer ' NextIntEx őÕVtg
    Private normal_sw As Integer  ' NextNormal ŎcĂ
    Private normal_save As Double ' NextNormal ̎c̒l
    Protected x(351) As UInteger ' ԃe[u
    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HE8148000&, &HD0C7AFA3&}

    Protected Overridable Function GetParity() As UInteger()
        Return ParityData
    End Function

    Public readonly Overridable Property IdString() As String
        Get
            Return "SFMT-11213:68-14-3-7-3:effff7fb-ffffffef-dfdfbfff-7fffdbfd"
        End Get
    End Property

    Protected Overridable Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 272 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 7) And &H7FFFDBFD)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 7) And &HDFDFBFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 7) And &HFFFFFFEF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 7) And &HEFFFF7FB)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Private Sub period_certification()
        Dim work As UInteger : Dim inner As UInteger = 0 : Dim i, j As Integer
        Dim parity As UInteger() = GetParity()

        index = 352 : range = 0 : normal_sw = 0 : coin_bits = 0 : byte_pos = 0
        For i = 0 To 3 : inner = inner Xor x(i) And parity(i) : Next
        i = 16 : Do : inner = inner Xor inner >> i : i >>= 1 : Loop While i > 0
        inner = inner And 1
        If inner = 1 Then Return
        For i = 0 To 3
            j = 0 : work = 1
            Do
                If (work And parity(i)) <> 0 Then
                    x(i) = x(i) Xor work
                    Return
                End If
                j += 1
                work <<= 1
            Loop While j < 32
        Next
    End Sub

    ' ̎ s ɂ鏉
    Public Sub InitMt(ByVal s As UInteger)
        Dim p As UInteger
        x(0) = s
        For p = 1 To 351
            s = 1812433253 * (s Xor (s >> 30)) + p
            x(p) = s
        Next
        period_certification()
    End Sub

    Sub New(ByVal s As UInteger)
        InitMt(s)
    End Sub
    
    ' z init_key ɂ鏉
    Public Sub InitMtEx(ByVal init_key() As UInteger)
        Dim r, i, j, c As UInteger
        Dim key_len As UInteger = init_key.Length

        For i = 0 To 351 : x(i) = &H8B8B8B8B& : Next
        If key_len + 1 > 352 Then c = key_len + 1 Else c = 352
        r = x(0) Xor x(172) Xor x(351) : r = (r Xor (r >> 27)) * 1664525
        x(172) += r : r += key_len : x(179) += r : x(0) = r : c -= 1
        i = 1 : j = 0
        Do While j < c And j < key_len
            r = x(i) Xor x((i + 172) Mod 352) Xor x((i + 351) Mod 352)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 172) Mod 352) += r
            r += init_key(j) + i : x((i + 179) Mod 352) += r
            x(i) = r : i = (i + 1) Mod 352 : j += 1
        Loop
        Do While j < c
            r = x(i) Xor x((i + 172) Mod 352) Xor x((i + 351) Mod 352)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 172) Mod 352) += r : r += i
            x((i + 179) Mod 352) += r : x(i) = r : i = (i + 1) Mod 352 : j += 1
        Loop
        For j = 0 To 351
            r = x(i) + x((i + 172) Mod 352) + x((i + 351) Mod 352)
            r = (r Xor (r >> 27)) * 1566083941
            c = (i + 172) Mod 352 : x(c) = x(c) Xor r : r -= i
            c = (i + 179) Mod 352 : x(c) = x(c) Xor r
            x(i) = r : i = (i + 1) Mod 352
        Next
        period_certification()
    End Sub


    Sub New(ByVal init_key() As UInteger)
        InitMtEx(init_key)
    End Sub
    
    ' 32rbgȂ̗
    Public Function NextMt() As UInteger
        If index = 352 Then
            gen_rand_all()
            index = 0
        End If
        nextmt = x(index)
        index += 1
    End Function

    ' Oȏ n ̐
    Public Function NextInt(ByVal n As Integer) As Integer
        Return Int(n * (1.0 / 4294967296.0) * NextMt())
    End Function

    ' OPԂ
    Public Function NextBit() As integer
        coin_bits = coin_bits - 1
        If coin_bits = -1 Then
            coin_bits = 31
            coin_save = NextMt
        Else
            coin_save = coin_save >> 1
        End If
        NextBit = coin_save And 1
    End Function

    ' OPԂ
    Public Function NextByte() As integer
        byte_pos = byte_pos - 1
        If byte_pos = -1 Then
            byte_pos = 3
            byte_save = NextMt
        Else
            byte_save = byte_save >> 8
        End If
        NextByte = byte_save And 255
    End Function

    ' OȏP̗(53bitx)
    Public Function NextUnif() As Double
        Dim z As UInteger = NextMt() >> 11
        Dim y As UInteger = NextMt()
        Return (y * 2097152.0 + z) * (1.0 / 9007199254740992.0)
    End Function

    ' ۂߌ덷̂ȂOȏ range_ ̐
    Public Function NextIntEx(ByVal range_ As Integer) As Integer
        Dim y_, base_, remain_, shift_ As UInteger

        If range_ <= 0 Then Return 0
        If range_ <> range Then
            range = range_ : bse = range_ : shift = 0
            Do While bse <= 1 << 30
                bse <<= 1 : shift += 1
            Loop
        End If
        Do
            y_ = NextMt() >> 1
            If y_ < bse Then Return int(y_ >> shift)
            base_ = bse : shift_ = shift : y_ -= base_
            remain_ = (1 << 31) - base_
            Do While remain_ >= range_
                Do While base_ > remain_
                    base_ >>= 1 : shift_ -= 1
                Loop
                If y_ < base_ Then Return int(y_ >> shift_)
                y_ -= base_
                remain_ -= base_
            Loop
        Loop
    End Function
    
    ' Rx˂̃JCQ敪z
    Public Function NextChisq(ByVal n As Double) As Double
        Return 2 * NextGamma(0.5 * n)
    End Function

    ' p[^̃K}z
    Public Function NextGamma(ByVal a As Double) As double
        Dim t, u, xx, y As Double
        If a > 1 Then
            t = Math.Sqrt(2 * a - 1)
            Do
                Do
                    Do
                        Do
                            xx = 1 - NextUnif()
                            y = 2 * NextUnif() - 1
                        Loop While xx * xx + y * y > 1
                        y /= xx : xx = t * y + a - 1
                    Loop While xx <= 0
                    u = (a - 1) * Math.Log(xx / (a - 1)) - t * y
                Loop While u < -50.0
            Loop While NextUnif() > (1 + y * y) * Math.Exp(u)
        Else
            t = 2.7182818284590451 / (a + 2.7182818284590451)
            Do
                If NextUnif() < t Then
                    xx = Math.Pow(NextUnif(), 1 / a) : y = Math.Exp(-xx)
                Else
                    xx = 1 - Math.Log(1 - NextUnif()) : y = Math.Pow(xx, a - 1)
                End If
            Loop While NextUnif() >= y
        End If
        Return xx
    End Function

    ' mo̊􉽕z
    Public Function NextGeometric(ByVal p As Double) As Integer
        Return int(Math.Ceiling(Math.Log(1.0 - NextUnif()) / Math.Log(1 - p)))
    End Function

    ' Opz
    Public Function NextTriangle() As Double
        Dim a As Double = NextUnif()
        Dim b As Double = NextUnif()

        Return a - b
    End Function
    
    ' ςP̎wz
    Public Function NextExp() As Double
        Return -Math.Log(1 - NextUnif())
    End Function

    ' WKz(ő8.57)
    Public Function NextNormal() As Double
        Dim t, u As Double
        If normal_sw = 0 Then
            t = Math.Sqrt(-2 * Math.Log(1.0 - NextUnif()))
            u = 3.1415926535897931 * 2 * NextUnif()
            normal_save = t * Math.Sin(u) : normal_sw = 1
            Return t * Math.Cos(u)
        Else
            normal_sw = 0 : Return normal_save
        End If
    End Function
    
    ' m̃_PʃxNg
    Public Sub NextUnitVect(ByRef v As Double(), ByVal n As Integer)
        Dim i As Integer : Dim r As Double = 0
        ReDim v(n - 1)
        For i = 0 To n - 1
            v(i) = NextNormal() : r += v(i) * v(i)
        Next
        If r = 0 Then
            r = 1
        End If
        r = Math.Sqrt(r)
        For i = 0 To n - 1 : v(i) /= r : Next
    End Sub

    ' p[^m,ôQz
    Public Function NextBinomial(ByVal n As Integer, ByVal p As Double) As Integer
        Dim i As Integer : Dim r As Integer = 0

        For i = 0 To n - 1
            If NextUnif() < p Then r += 1
        Next
        Return r
    End Function

    ' ֌Wq̂QϗʐKz
    Public Sub NextBinormal(ByVal r As Double, ByRef a As Double, ByRef b As Double)
        Dim r1, r2, s As Double
        Do
            r1 = 2 * NextUnif() - 1
            r2 = 2 * NextUnif() - 1
            s = r1 * r1 + r2 * r2
        Loop While s > 1 Or s = 0
        s = -Math.Log(s) / s : r1 = Math.Sqrt((1 + r) * s) * r1
        r2 = Math.Sqrt((1 - r) * s) * r2 : a = r1 + r2 : b = r1 - r2
    End Sub

    ' p[^`,ãx[^z
    Public Function NextBeta(ByVal a As Double, ByVal b As Double) As Double
        Dim temp As Double = NextGamma(a)
        Return temp / (temp + NextGamma(b))
    End Function

    ' p[^m̗ݏ敪z
    Public Function NextPower(ByVal n As Double) As Double
        Return Math.Pow(NextUnif(), 1.0 / (n + 1))
    End Function

    ' WXeBbNz
    Public Function NextLogistic() As Double
        Dim r As Double
        Do : r = NextUnif() : Loop While r = 0
        Return Math.Log(r / (1 - r))
    End Function

    ' R[V[z
    Public Function NextCauchy() As Double
        Dim x, y As Double
        Do
            x = 1 - NextUnif() : y = 2 * NextUnif() - 1
        Loop While x * x + y * y > 1
        Return y / x
    End Function

    ' Rx n1,n2 ̂ez
    Public Function NextFDist(ByVal n1 As Double, ByVal n2 As Double) As Double
        Dim nc1 As Double = NextChisq(n1)
        Dim nc2 As Double = NextChisq(n2)
        Return (nc1 * n2) / (nc2 * n1)
    End Function

    ' σɂ̃|A\z
    Public Function NextPoisson(ByVal lambda As Double) As Integer
        Dim k As Integer = 0

        lambda = Math.Exp(lambda) * NextUnif()
        Do While lambda > 1
            lambda *= NextUnif()
            k += 1
        Loop
        Return k
    End Function

    ' Rxm̂z
    Public Function NextTDist(ByVal n As Double) As Double
        Dim a, b, c As Double
        If n <= 2 Then
            Do : a = NextChisq(n) : Loop While a = 0
            Return NextNormal() / Math.Sqrt(a / n)
        End If
        Do
            a = NextNormal() : b = a * a / (n - 2)
            c = Math.Log(1 - NextUnif()) / (1 - 0.5 * n)
        Loop While Math.Exp(-b - c) > 1 - b
        Return a / Math.Sqrt((1 - 2.0 / n) * (1 - b))
    End Function

    ' p[^̃Cuz
    Public Function NextWeibull(ByVal alpha As Double) As Double
        Return Math.Pow(-Math.Log(1 - NextUnif()), 1 / alpha)
    End Function
End Class

Class Sfmt1
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:73-11-3-2-5:ff6ffcff-bff77dff-77dfffff-fbfffffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HBCAAA000&, &H278C70BE&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 292 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 2) And &HFBFFFFFB)
            p(a + 3) = y Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 2) And &H77DFFFFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 2) And &HBFF77DFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 2) And &HFF6FFCFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt2
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:72-13-3-1-1:7ff7ffff-afffcdde-effffeff-ffffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H3DC0000&, &H1F9394F8&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 288 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 1) And &HFFFFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 1) And &HEFFFFEFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 1) And &HAFFFCDDE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 1) And &H7FF7FFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt3
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:63-22-1-13-1:f5fbfffb-ffffffbf-df7ffcb7-dffff7ff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HF73CA000&, &H2AD648B9&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 252 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 13) And &HDFFFF7FF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 22)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 13) And &HDF7FFCB7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 22)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 13) And &HFFFFFFBF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 22)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 13) And &HF5FBFFFB)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 22)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt4
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:73-12-3-9-1:ddffdff7-6baffff7-7bd5ffff-efd3fbff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HF75E8000&, &HB53672E0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 292 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 9) And &HEFD3FBFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 12)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 9) And &H7BD5FFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 12)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 9) And &H6BAFFFF7)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 12)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 9) And &HDDFFDFF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 12)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt5
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:48-10-3-9-5:5dffefcd-c6ffffdf-fe77bfff-ffefefff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H6F4EA000&, &H1B8DB4BA&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 192 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 9) And &HFFEFEFFF)
            p(a + 3) = y Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 9) And &HFE77BFFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 9) And &HC6FFFFDF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 9) And &H5DFFEFCD)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt6
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:45-13-3-10-5:fbffd7ff-ddf7f7e7-9bffe71f-ff7ec3ff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H830E0000&, &HCD4127AF&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 180 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 10) And &HFF7EC3FF)
            p(a + 3) = y Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 10) And &H9BFFE71F)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 10) And &HDDF7F7E7)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 10) And &HFBFFD7FF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt7
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:58-7-7-5-1:7defffff-7d9bffff-fdbff7ee-dfffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H5B202000&, &H95B190FD&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 232 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 5) And &HDFFFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 7)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 5) And &HFDBFF7EE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 7)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 5) And &H7D9BFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 7)
            y = p(a) Xor ((p(b) >> 5) And &H7DEFFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 7)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt8
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:86-19-1-5-1:fffffebf-fdeffadf-7fb71fcf-ffff5fff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H953E8000&, &HF7BD34C4&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 344 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HFFFF5FFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &H7FB71FCF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &HFDEFFADF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &HFFFFFEBF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt9
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:84-22-1-7-1:fff7effe-bfb7afff-b7dfffff-bf7f7fef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HE1D70000&, &H2717D9D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 336 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 7) And &HBF7F7FEF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 22)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 7) And &HB7DFFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 22)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 7) And &HBFB7AFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 22)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 7) And &HFFF7EFFE)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 22)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt10
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:33-6-7-7-1:fffff9ff-fb7fffff-ebeffdfe-fbfbffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H8A3D0800&, &H26E932D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 132 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 7) And &HFBFBFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 7) And &HEBEFFDFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 7) And &HFB7FFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor ((p(b) >> 7) And &HFFFFF9FF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt11
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:22-14-7-7-1:fffefbf7-effffb7e-fefdfbbf-e7ffffdf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H5C142000&, &HAAEFE70&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 88 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 7) And &HE7FFFFDF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 7) And &HFEFDFBBF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 7) And &HEFFFFB7E)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor ((p(b) >> 7) And &HFFFEFBF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt12
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:79-22-1-17-1:ffbf7ff7-9dffdfdf-dfef97bf-dfeebf7f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H68CBE000&, &H1C20BDD1&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 316 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 17) And &HDFEEBF7F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 22)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 17) And &HDFEF97BF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 22)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 17) And &H9DFFDFDF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 22)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 17) And &HFFBF7FF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 22)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt13
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:77-9-3-10-3:fffffffe-3feefbff-f7fefeff-f5bc9fff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H73B20000&, &HB134EF9C&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 308 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 10) And &HF5BC9FFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 9)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 10) And &HF7FEFEFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 9)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 10) And &H3FEEFBFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 9)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 10) And &HFFFFFFFE)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 9)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt14
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:45-17-1-6-3:f77bbfef-bcf7bfdf-bffff7e7-fffaff7b"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HCE408000&, &H1344DAD1&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 180 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 6) And &HFFFAFF7B)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 17)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 6) And &HBFFFF7E7)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 17)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 6) And &HBCF7BFDF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 17)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 6) And &HF77BBFEF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 17)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt15
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:41-13-1-4-3:fb5d7fff-fbff7bff-f7ff677f-c67fffbf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HEB18000&, &HAFE068E2&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 164 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 4) And &HC67FFFBF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 4) And &HF7FF677F)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 4) And &HFBFF7BFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 4) And &HFB5D7FFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt16
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:69-6-3-3-1:effdfdff-f9bffbff-dff1ffff-f7f8dfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H83409000&, &HC4651BF2&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 276 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 3) And &HF7F8DFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 3) And &HDFF1FFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 3) And &HF9BFFBFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 3) And &HEFFDFDFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt17
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:48-12-3-17-1:de5fffbf-f7d5f7be-fff7757d-fffeef79"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HA25C0200&, &HA9CB6A61&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 192 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 17) And &HFFFEEF79)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 12)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 17) And &HFFF7757D)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 12)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 17) And &HF7D5F7BE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 12)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 17) And &HDE5FFFBF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 12)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt18
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:9-18-5-15-1:5fe7eff7-dbffdff3-dbff6ff7-bb377fff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HA0B64800&, &HC3969FA3&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 36 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 15) And &HBB377FFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 15) And &HDBFF6FF7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 15) And &HDBFFDFF3)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 18)
            y = p(a) Xor ((p(b) >> 15) And &H5FE7EFF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt19
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:48-11-7-17-1:ffd7ebff-efffff7b-efbfffbd-f7f7efae"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H76ADC000&, &HDD5C6C66&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 192 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 17) And &HF7F7EFAE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 17) And &HEFBFFFBD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 17) And &HEFFFFF7B)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 17) And &HFFD7EBFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt20
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:36-5-7-17-1:ccfe7ffe-fadfffff-fffffdff-ffefefff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H637CD000&, &HEDD65806&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 144 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 17) And &HFFEFEFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 17) And &HFFFFFDFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 17) And &HFADFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor ((p(b) >> 17) And &HCCFE7FFE)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt21
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:12-7-3-11-1:fffbe5fb-fdfdf7df-fffdf7ff-fffffffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H43F60800&, &H4F337B1D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 48 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HFFFFFFFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 7)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &HFFFDF7FF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 7)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &HFDFDF7DF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 7)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &HFFFBE5FB)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 7)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt22
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:37-21-3-4-5:76fe7fff-79ffffff-7ff7dfff-bbfbefff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H2AA69000&, &HA1BD24DD&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 148 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 4) And &HBBFBEFFF)
            p(a + 3) = y Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 4) And &H7FF7DFFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 4) And &H79FFFFFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 4) And &H76FE7FFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt23
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:85-19-7-10-1:fffdfbff-ffbffa3f-ffbffa2f-ffdfffbf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HFE0C8800&, &HCEED51F4&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 340 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 10) And &HFFDFFFBF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 10) And &HFFBFFA2F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 10) And &HFFBFFA3F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor ((p(b) >> 10) And &HFFFDFBFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt24
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:42-13-7-21-1:ff3ebfbe-ff7fffde-5ffffbef-fffefbfb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H443A000&, &H35321B2A&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 168 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 21) And &HFFFEFBFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 21) And &H5FFFFBEF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 21) And &HFF7FFFDE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor ((p(b) >> 21) And &HFF3EBFBE)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt25
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:38-16-3-1-5:fdf7dbff-fbffdffb-fbffbfd9-fffffdbd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H16D92000&, &HACD93BF9&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 152 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 1) And &HFFFFFDBD)
            p(a + 3) = y Xor (p(d + 3) << 16)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 1) And &HFBFFBFD9)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 16)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 1) And &HFBFFDFFB)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 16)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 1) And &HFDF7DBFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 16)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt26
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:80-3-3-1-3:f77efedf-f7fffbeb-cbffffe7-fdfffbff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HBCA5A000&, &H45E06438&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 320 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 1) And &HFDFFFBFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 3)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 1) And &HCBFFFFE7)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 3)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 1) And &HF7FFFBEB)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 3)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 1) And &HF77EFEDF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 3)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt27
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:37-21-7-6-1:ffcffdff-fedffdff-fcbffffb-ffeffebf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HF8270000&, &HF6FDF776&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 148 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 6) And &HFFEFFEBF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 6) And &HFCBFFFFB)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 6) And &HFEDFFDFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor ((p(b) >> 6) And &HFFCFFDFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt28
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:14-11-1-21-1:ffffffbd-ff7feffe-b6ffd7ff-97f9fe7f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H22D14000&, &HF393E8A4&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 56 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 21) And &H97F9FE7F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 21) And &HB6FFD7FF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 21) And &HFF7FEFFE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 21) And &HFFFFFFBD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt29
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:16-27-1-5-3:dfffef7f-eff97fdf-fff3fcfa-fe7feeff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H16F44800&, &H24CE4227&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 64 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HFE7FEEFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 27)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &HFFF3FCFA)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 27)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &HEFF97FDF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 27)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &HDFFFEF7F)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 27)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt30
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:85-5-7-14-1:ffbfeffe-fbfddbeb-fbdfffff-bfffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &HA7420000&, &HEA7B6CA0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 340 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 14) And &HBFFFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 14) And &HFBDFFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 14) And &HFBFDDBEB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor ((p(b) >> 14) And &HFFBFEFFE)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt31
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-11213:13-15-5-10-3:fffaffff-effef9ff-fe7e9bdb-ff7ffbfe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H42C21400&, &HFDE64440&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 52 : Dim c As Integer = 344
        Dim d As Integer = 348 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 10) And &HFF7FFBFE)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 15)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 10) And &HFE7E9BDB)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 15)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 10) And &HEFFEF9FF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 15)
            y = p(a) Xor ((p(b) >> 10) And &HFFFAFFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 15)
            c = d : d = a : a += 4 : b += 4
            If b = 352 Then b = 0
        Loop While a <> 352
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt_m

    Private Shared z as Sfmt() = { _
        New Sfmt  (1), _
        New Sfmt1 (&HFFFFFFFF&), _
        New Sfmt2 (&HFFFFFFFE&), _
        New Sfmt3 (&HFFFFFFFD&), _
        New Sfmt4 (&HFFFFFFFC&), _
        New Sfmt5 (&HFFFFFFFB&), _
        New Sfmt6 (&HFFFFFFFA&), _
        New Sfmt7 (&HFFFFFFF9&), _
        New Sfmt8 (&HFFFFFFF8&), _
        New Sfmt9 (&HFFFFFFF7&), _
        New Sfmt10(&HFFFFFFF6&), _
        New Sfmt11(&HFFFFFFF5&), _
        New Sfmt12(&HFFFFFFF4&), _
        New Sfmt13(&HFFFFFFF3&), _
        New Sfmt14(&HFFFFFFF2&), _
        New Sfmt15(&HFFFFFFF1&), _
        New Sfmt16(&HFFFFFFF0&), _
        New Sfmt17(&HFFFFFFEF&), _
        New Sfmt18(&HFFFFFFEE&), _
        New Sfmt19(&HFFFFFFED&), _
        New Sfmt20(&HFFFFFFEC&), _
        New Sfmt21(&HFFFFFFEB&), _
        New Sfmt22(&HFFFFFFEA&), _
        New Sfmt23(&HFFFFFFE9&), _
        New Sfmt24(&HFFFFFFE8&), _
        New Sfmt25(&HFFFFFFE7&), _
        New Sfmt26(&HFFFFFFE6&), _
        New Sfmt27(&HFFFFFFE5&), _
        New Sfmt28(&HFFFFFFE4&), _
        New Sfmt29(&HFFFFFFE3&), _
        New Sfmt30(&HFFFFFFE2&), _
        New Sfmt31(&HFFFFFFE1&) _
    }

    Public Shared Function IdString_m(ByVal i As Integer) As String
        Return z(i).IdString
    End Function

    Public Shared Sub InitMt_m(ByVal i As Integer,ByVal s As UInteger)
        z(i).InitMt(s)
    End Sub

    Public Shared Sub InitMtEx_m(ByVal i As Integer,ByVal k As UInteger())
        z(i).InitMtEx(k)
    End Sub

    Public Shared Function NextMt_m(ByVal i As Integer) As UInteger
        Return z(i).NextMt()
    End Function

    Public Shared Function NextInt_m(ByVal i As Integer,ByVal n As Integer) As Integer
        Return z(i).NextInt(n)
    End Function

    Public Shared Function NextBit_m(ByVal i As Integer) As Integer
        Return z(i).NextBit()
    End Function

    Public Shared Function NextByte_m(ByVal i As Integer) As Integer
        Return z(i).NextByte()
    End Function

    Public Shared Function NextUnif_m(ByVal i As Integer) As Double
        Return z(i).NextUnif()
    End Function

    Public Shared Function NextIntEx_m(ByVal i As Integer,ByVal r As Integer) As Integer
        Return z(i).NextIntEx(r)
    End Function

    Public Shared Function NextChisq_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextChisq(n)
    End Function

    Public Shared Function NextGamma_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextGamma(a)
    End Function

    Public Shared Function NextGeometric_m(ByVal i As Integer,ByVal p As Double) As Integer
        Return z(i).NextGeometric(p)
    End Function

    Public Shared Function NextTriangle_m(ByVal i As Integer) As Double
        Return z(i).NextTriangle()
    End Function

    Public Shared Function NextExp_m(ByVal i As Integer) As Double
        Return z(i).NextExp()
    End Function

    Public Shared Function NextNormal_m(ByVal i As Integer) As Double
        Return z(i).NextNormal()
    End Function

    Public Shared Sub NextUnitVect_m(ByVal i As Integer,ByRef v As Double(),ByVal n As Integer)
        z(i).NextUnitVect(v,n)
    End Sub

    Public Shared Function NextBinomial_m(ByVal i As Integer,ByVal n As Integer,ByVal p As Double) As Integer
        Return z(i).NextBinomial(n,p)
    End Function

    Public Shared Sub NextBinormal_m(ByVal i As Integer,ByVal r As Double,ByRef a As Double,ByRef b As Double)
        z(i).NextBinormal(r,a,b)
    End Sub

    Public Shared Function NextBeta_m(ByVal i As Integer,ByVal a As Double,ByVal b As Double) As Double
        Return z(i).NextBeta(a,b)
    End Function

    Public Shared Function NextPower_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextPower(n)
    End Function

    Public Shared Function NextLogistic_m(ByVal i As Integer) As Double
        Return z(i).NextLogistic()
    End Function

    Public Shared Function NextCauchy_m(ByVal i As Integer) As Double
        Return z(i).NextCauchy()
    End Function

    Public Shared Function NextPoisson_m(ByVal i As Integer,ByVal l As Double) As Integer
        Return z(i).NextPoisson(l)
    End Function

    Public Shared Function NextFDist_m(ByVal i As Integer,ByVal n1 As Double,ByVal n2 As Double) As Double
        Return z(i).NextFDist(n1,n2)
    End Function

    Public Shared Function NextTDist_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextTDist(n)
    End Function

    Public Shared Function NextWeibull_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextWeibull(a)
    End Function

End Class

