'
' Sfmt2281.vb Cu
' coded by isaku@pb4.so-net.ne.jp
' 

Class Sfmt

    Private index As Integer
    Private coin_bits As Integer ' NextBit ł̎c̃rbg
    Private coin_save As UInteger ' NextBit ł̒lێ
    Private byte_pos As Integer ' NextByte ŎgpoCg
    Private byte_save As UInteger ' NextByte ł̒lێ
    Private range As Integer ' NextIntEx őO͈̔
    Private bse As UInteger  ' NextIntEx őO̊l
    Private shift As Integer ' NextIntEx őÕVtg
    Private normal_sw As Integer  ' NextNormal ŎcĂ
    Private normal_save As Double ' NextNormal ̎c̒l
    Protected x(71) As UInteger ' ԃe[u
    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H41DFA600&}

    Protected Overridable Function GetParity() As UInteger()
        Return ParityData
    End Function

    Public readonly Overridable Property IdString() As String
        Get
            Return "SFMT-2281:12-19-1-5-1:bff7ffbf-fdfffffe-f7ffef7f-f2f7cbbf"
        End Get
    End Property

    Protected Overridable Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 48 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HF2F7CBBF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &HF7FFEF7F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &HFDFFFFFE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &HBFF7FFBF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Private Sub period_certification()
        Dim work As UInteger : Dim inner As UInteger = 0 : Dim i, j As Integer
        Dim parity As UInteger() = GetParity()

        index = 72 : range = 0 : normal_sw = 0 : coin_bits = 0 : byte_pos = 0
        For i = 0 To 3 : inner = inner Xor x(i) And parity(i) : Next
        i = 16 : Do : inner = inner Xor inner >> i : i >>= 1 : Loop While i > 0
        inner = inner And 1
        If inner = 1 Then Return
        For i = 0 To 3
            j = 0 : work = 1
            Do
                If (work And parity(i)) <> 0 Then
                    x(i) = x(i) Xor work
                    Return
                End If
                j += 1
                work <<= 1
            Loop While j < 32
        Next
    End Sub

    ' ̎ s ɂ鏉
    Public Sub InitMt(ByVal s As UInteger)
        Dim p As UInteger
        x(0) = s
        For p = 1 To 71
            s = 1812433253 * (s Xor (s >> 30)) + p
            x(p) = s
        Next
        period_certification()
    End Sub

    Sub New(ByVal s As UInteger)
        InitMt(s)
    End Sub
    
    ' z init_key ɂ鏉
    Public Sub InitMtEx(ByVal init_key() As UInteger)
        Dim r, i, j, c As UInteger
        Dim key_len As UInteger = init_key.Length

        For i = 0 To 71 : x(i) = &H8B8B8B8B& : Next
        If key_len + 1 > 72 Then c = key_len + 1 Else c = 72
        r = x(0) Xor x(32) Xor x(71) : r = (r Xor (r >> 27)) * 1664525
        x(32) += r : r += key_len : x(39) += r : x(0) = r : c -= 1
        i = 1 : j = 0
        Do While j < c And j < key_len
            r = x(i) Xor x((i + 32) Mod 72) Xor x((i + 71) Mod 72)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 32) Mod 72) += r
            r += init_key(j) + i : x((i + 39) Mod 72) += r
            x(i) = r : i = (i + 1) Mod 72 : j += 1
        Loop
        Do While j < c
            r = x(i) Xor x((i + 32) Mod 72) Xor x((i + 71) Mod 72)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 32) Mod 72) += r : r += i
            x((i + 39) Mod 72) += r : x(i) = r : i = (i + 1) Mod 72 : j += 1
        Loop
        For j = 0 To 71
            r = x(i) + x((i + 32) Mod 72) + x((i + 71) Mod 72)
            r = (r Xor (r >> 27)) * 1566083941
            c = (i + 32) Mod 72 : x(c) = x(c) Xor r : r -= i
            c = (i + 39) Mod 72 : x(c) = x(c) Xor r
            x(i) = r : i = (i + 1) Mod 72
        Next
        period_certification()
    End Sub


    Sub New(ByVal init_key() As UInteger)
        InitMtEx(init_key)
    End Sub
    
    ' 32rbgȂ̗
    Public Function NextMt() As UInteger
        If index = 72 Then
            gen_rand_all()
            index = 0
        End If
        nextmt = x(index)
        index += 1
    End Function

    ' Oȏ n ̐
    Public Function NextInt(ByVal n As Integer) As Integer
        Return Int(n * (1.0 / 4294967296.0) * NextMt())
    End Function

    ' OPԂ
    Public Function NextBit() As integer
        coin_bits = coin_bits - 1
        If coin_bits = -1 Then
            coin_bits = 31
            coin_save = NextMt
        Else
            coin_save = coin_save >> 1
        End If
        NextBit = coin_save And 1
    End Function

    ' OPԂ
    Public Function NextByte() As integer
        byte_pos = byte_pos - 1
        If byte_pos = -1 Then
            byte_pos = 3
            byte_save = NextMt
        Else
            byte_save = byte_save >> 8
        End If
        NextByte = byte_save And 255
    End Function

    ' OȏP̗(53bitx)
    Public Function NextUnif() As Double
        Dim z As UInteger = NextMt() >> 11
        Dim y As UInteger = NextMt()
        Return (y * 2097152.0 + z) * (1.0 / 9007199254740992.0)
    End Function

    ' ۂߌ덷̂ȂOȏ range_ ̐
    Public Function NextIntEx(ByVal range_ As Integer) As Integer
        Dim y_, base_, remain_, shift_ As UInteger

        If range_ <= 0 Then Return 0
        If range_ <> range Then
            range = range_ : bse = range_ : shift = 0
            Do While bse <= 1 << 30
                bse <<= 1 : shift += 1
            Loop
        End If
        Do
            y_ = NextMt() >> 1
            If y_ < bse Then Return int(y_ >> shift)
            base_ = bse : shift_ = shift : y_ -= base_
            remain_ = (1 << 31) - base_
            Do While remain_ >= range_
                Do While base_ > remain_
                    base_ >>= 1 : shift_ -= 1
                Loop
                If y_ < base_ Then Return int(y_ >> shift_)
                y_ -= base_
                remain_ -= base_
            Loop
        Loop
    End Function
    
    ' Rx˂̃JCQ敪z
    Public Function NextChisq(ByVal n As Double) As Double
        Return 2 * NextGamma(0.5 * n)
    End Function

    ' p[^̃K}z
    Public Function NextGamma(ByVal a As Double) As double
        Dim t, u, xx, y As Double
        If a > 1 Then
            t = Math.Sqrt(2 * a - 1)
            Do
                Do
                    Do
                        Do
                            xx = 1 - NextUnif()
                            y = 2 * NextUnif() - 1
                        Loop While xx * xx + y * y > 1
                        y /= xx : xx = t * y + a - 1
                    Loop While xx <= 0
                    u = (a - 1) * Math.Log(xx / (a - 1)) - t * y
                Loop While u < -50.0
            Loop While NextUnif() > (1 + y * y) * Math.Exp(u)
        Else
            t = 2.7182818284590451 / (a + 2.7182818284590451)
            Do
                If NextUnif() < t Then
                    xx = Math.Pow(NextUnif(), 1 / a) : y = Math.Exp(-xx)
                Else
                    xx = 1 - Math.Log(1 - NextUnif()) : y = Math.Pow(xx, a - 1)
                End If
            Loop While NextUnif() >= y
        End If
        Return xx
    End Function

    ' mo̊􉽕z
    Public Function NextGeometric(ByVal p As Double) As Integer
        Return int(Math.Ceiling(Math.Log(1.0 - NextUnif()) / Math.Log(1 - p)))
    End Function

    ' Opz
    Public Function NextTriangle() As Double
        Dim a As Double = NextUnif()
        Dim b As Double = NextUnif()

        Return a - b
    End Function
    
    ' ςP̎wz
    Public Function NextExp() As Double
        Return -Math.Log(1 - NextUnif())
    End Function

    ' WKz(ő8.57)
    Public Function NextNormal() As Double
        Dim t, u As Double
        If normal_sw = 0 Then
            t = Math.Sqrt(-2 * Math.Log(1.0 - NextUnif()))
            u = 3.1415926535897931 * 2 * NextUnif()
            normal_save = t * Math.Sin(u) : normal_sw = 1
            Return t * Math.Cos(u)
        Else
            normal_sw = 0 : Return normal_save
        End If
    End Function
    
    ' m̃_PʃxNg
    Public Sub NextUnitVect(ByRef v As Double(), ByVal n As Integer)
        Dim i As Integer : Dim r As Double = 0
        ReDim v(n - 1)
        For i = 0 To n - 1
            v(i) = NextNormal() : r += v(i) * v(i)
        Next
        If r = 0 Then
            r = 1
        End If
        r = Math.Sqrt(r)
        For i = 0 To n - 1 : v(i) /= r : Next
    End Sub

    ' p[^m,ôQz
    Public Function NextBinomial(ByVal n As Integer, ByVal p As Double) As Integer
        Dim i As Integer : Dim r As Integer = 0

        For i = 0 To n - 1
            If NextUnif() < p Then r += 1
        Next
        Return r
    End Function

    ' ֌Wq̂QϗʐKz
    Public Sub NextBinormal(ByVal r As Double, ByRef a As Double, ByRef b As Double)
        Dim r1, r2, s As Double
        Do
            r1 = 2 * NextUnif() - 1
            r2 = 2 * NextUnif() - 1
            s = r1 * r1 + r2 * r2
        Loop While s > 1 Or s = 0
        s = -Math.Log(s) / s : r1 = Math.Sqrt((1 + r) * s) * r1
        r2 = Math.Sqrt((1 - r) * s) * r2 : a = r1 + r2 : b = r1 - r2
    End Sub

    ' p[^`,ãx[^z
    Public Function NextBeta(ByVal a As Double, ByVal b As Double) As Double
        Dim temp As Double = NextGamma(a)
        Return temp / (temp + NextGamma(b))
    End Function

    ' p[^m̗ݏ敪z
    Public Function NextPower(ByVal n As Double) As Double
        Return Math.Pow(NextUnif(), 1.0 / (n + 1))
    End Function

    ' WXeBbNz
    Public Function NextLogistic() As Double
        Dim r As Double
        Do : r = NextUnif() : Loop While r = 0
        Return Math.Log(r / (1 - r))
    End Function

    ' R[V[z
    Public Function NextCauchy() As Double
        Dim x, y As Double
        Do
            x = 1 - NextUnif() : y = 2 * NextUnif() - 1
        Loop While x * x + y * y > 1
        Return y / x
    End Function

    ' Rx n1,n2 ̂ez
    Public Function NextFDist(ByVal n1 As Double, ByVal n2 As Double) As Double
        Dim nc1 As Double = NextChisq(n1)
        Dim nc2 As Double = NextChisq(n2)
        Return (nc1 * n2) / (nc2 * n1)
    End Function

    ' σɂ̃|A\z
    Public Function NextPoisson(ByVal lambda As Double) As Integer
        Dim k As Integer = 0

        lambda = Math.Exp(lambda) * NextUnif()
        Do While lambda > 1
            lambda *= NextUnif()
            k += 1
        Loop
        Return k
    End Function

    ' Rxm̂z
    Public Function NextTDist(ByVal n As Double) As Double
        Dim a, b, c As Double
        If n <= 2 Then
            Do : a = NextChisq(n) : Loop While a = 0
            Return NextNormal() / Math.Sqrt(a / n)
        End If
        Do
            a = NextNormal() : b = a * a / (n - 2)
            c = Math.Log(1 - NextUnif()) / (1 - 0.5 * n)
        Loop While Math.Exp(-b - c) > 1 - b
        Return a / Math.Sqrt((1 - 2.0 / n) * (1 - b))
    End Function

    ' p[^̃Cuz
    Public Function NextWeibull(ByVal alpha As Double) As Double
        Return Math.Pow(-Math.Log(1 - NextUnif()), 1 / alpha)
    End Function
End Class

Class Sfmt1
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:12-10-3-5-1:fbdffff7-cfbffffe-fdfffffb-bcdffffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H92730900&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 48 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 5) And &HBCDFFFFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 5) And &HFDFFFFFB)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 5) And &HCFBFFFFE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 5) And &HFBDFFFF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt2
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:7-9-3-4-1:dfffef7b-ffefffff-fcfeffff-b6ff77cf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H907C9C00&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 28 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 4) And &HB6FF77CF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 9)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 4) And &HFCFEFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 9)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 4) And &HFFEFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 9)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 4) And &HDFFFEF7B)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 9)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt3
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:8-10-3-7-1:dbffedff-fffbfffd-f7ffffdf-ffff7ff7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HA826800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 7) And &HFFFF7FF7)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 7) And &HF7FFFFDF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 7) And &HFFFBFFFD)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 7) And &HDBFFEDFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt4
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:5-10-3-9-5:3f7ffbff-fffffff9-bffffbfe-9ffff7ff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H92E7DE00&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 20 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 9) And &H9FFFF7FF)
            p(a + 3) = y Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 9) And &HBFFFFBFE)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 9) And &HFFFFFFF9)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 9) And &H3F7FFBFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt5
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:10-10-3-9-3:ff9ffff7-fdffffff-bf3f7fff-fbffff7c"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HC66E2000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 40 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 9) And &HFBFFFF7C)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 9) And &HBF3F7FFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 9) And &HFDFFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 9) And &HFF9FFFF7)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt6
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:11-8-3-5-5:ff6ffba9-fffff7f7-ffdfdfff-f2ffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H1B40E800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 44 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 5) And &HF2FFFFFF)
            p(a + 3) = y Xor (p(d + 3) << 8)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 5) And &HFFDFDFFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 8)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 5) And &HFFFFF7F7)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 8)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 5) And &HFF6FFBA9)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 8)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt7
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:3-14-3-11-5:7bffffdf-3ffb7fdb-3f777ffb-fffefdbb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H3530D200&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HFFFEFDBB)
            p(a + 3) = y Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &H3F777FFB)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &H3FFB7FDB)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &H7BFFFFDF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt8
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:11-14-7-5-1:f7bffff9-6efff7ff-fbfbffdf-fff8ffbf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H48ACB400&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 44 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 5) And &HFFF8FFBF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 5) And &HFBFBFFDF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 5) And &H6EFFF7FF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor ((p(b) >> 5) And &HF7BFFFF9)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt9
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:2-20-1-5-3:ffffffbf-7dffdfeb-df7fffdf-feff69ee"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H32455000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HFEFF69EE)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 20)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &HDF7FFFDF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 20)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &H7DFFDFEB)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 20)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &HFFFFFFBF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 20)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt10
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:5-10-3-15-5:fff3ecfd-ffffff77-9f9fadff-b9d3ebdd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HB05F9800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 20 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 15) And &HB9D3EBDD)
            p(a + 3) = y Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 15) And &H9F9FADFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 15) And &HFFFFFF77)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 15) And &HFFF3ECFD)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt11
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:15-13-1-4-1:ffffff1b-ffbff77b-bfbffffe-fffbfaf5"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H27B07600&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 60 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 4) And &HFFFBFAF5)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 4) And &HBFBFFFFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 4) And &HFFBFF77B)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 4) And &HFFFFFF1B)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt12
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:5-5-3-6-1:dfff7dff-ff79fffe-eff77ffd-effb75df"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HC22BF800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 20 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 6) And &HEFFB75DF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 6) And &HEFF77FFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 6) And &HFF79FFFE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 6) And &HDFFF7DFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt13
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:16-18-5-1-1:7ffffbff-fffff7bf-df7e6fff-fff7cfcf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H3D350A80&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 64 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 1) And &HFFF7CFCF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 1) And &HDF7E6FFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 1) And &HFFFFF7BF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 18)
            y = p(a) Xor ((p(b) >> 1) And &H7FFFFBFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt14
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:15-19-3-14-1:ffffdbbf-cbf7ffff-fffebbfd-befebfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H147A0200&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 60 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 14) And &HBEFEBFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 14) And &HFFFEBBFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 14) And &HCBF7FFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 14) And &HFFFFDBBF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt15
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:9-10-7-13-1:dfffeeef-fffffddf-fbfbfe5f-cffbfdef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HDB3CCE00&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 36 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 13) And &HCFFBFDEF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 13) And &HFBFBFE5F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 13) And &HFFFFFDDF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor ((p(b) >> 13) And &HDFFFEEEF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt16
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:4-14-3-13-1:d7ffffdf-bfdfffff-fbfffdfe-5ffbffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H11ECC00&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 16 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 13) And &H5FFBFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 13) And &HFBFFFDFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 13) And &HBFDFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 13) And &HD7FFFFDF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt17
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:1-11-3-24-1:f3fbbfff-bffffffb-df7fd7bd-ff7edffd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H7AEE200&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 24) And &HFF7EDFFD)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 24) And &HDF7FD7BD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 24) And &HBFFFFFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 24) And &HF3FBBFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt18
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:6-9-7-21-1:beddbdff-fbffbd7f-f95b7fff-7fefbfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H197E2080&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 21) And &H7FEFBFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 9)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 21) And &HF95B7FFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 9)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 21) And &HFBFFBD7F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 9)
            y = p(a) Xor ((p(b) >> 21) And &HBEDDBDFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 9)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt19
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:1-9-3-12-1:eff7fcfa-f3ee7fef-bdb47dff-dbf6dfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H2BBD0A00&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 12) And &HDBF6DFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 9)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 12) And &HBDB47DFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 9)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 12) And &HF3EE7FEF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 9)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 12) And &HEFF7FCFA)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 9)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt20
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:1-18-5-7-3:efffffe7-ffffdfdf-ffffffff-5fff4aff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H8A50E100&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 7) And &H5FFF4AFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 7) And &HFFFFFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 7) And &HFFFFDFDF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 18)
            y = p(a) Xor ((p(b) >> 7) And &HEFFFFFE7)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt21
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:11-19-7-12-3:f7bfffff-eddfffff-f77ffd7f-eff7ffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H502BDC20&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 44 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 12) And &HEFF7FFFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 12) And &HF77FFD7F)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 12) And &HEDDFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 19)
            y = p(a) Xor ((p(b) >> 12) And &HF7BFFFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt22
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:10-19-3-17-1:effbdfff-fffdbeed-fefd3fbf-ff5beffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HDEDC0400&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 40 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 17) And &HFF5BEFFE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 17) And &HFEFD3FBF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 17) And &HFFFDBEED)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 17) And &HEFFBDFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt23
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:11-17-7-20-1:bdffddfd-dfdffffc-bffeffd6-ff7fffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H3923E800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 44 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 20) And &HFF7FFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 17)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 20) And &HBFFEFFD6)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 17)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 20) And &HDFDFFFFC)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 17)
            y = p(a) Xor ((p(b) >> 20) And &HBDFFDDFD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 17)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt24
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:9-21-3-20-5:ffffffdf-dfffffff-ff6ffffa-ffffdfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H8A9B2080&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 36 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 20) And &HFFFFDFFF)
            p(a + 3) = y Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 20) And &HFF6FFFFA)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 20) And &HDFFFFFFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 20) And &HFFFFFFDF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt25
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:5-4-7-19-1:ffbfbfff-ffffbfff-fff7ceee-ffffefff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H859DF000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 20 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 19) And &HFFFFEFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 4)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 19) And &HFFF7CEEE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 4)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 19) And &HFFFFBFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 4)
            y = p(a) Xor ((p(b) >> 19) And &HFFBFBFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 4)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt26
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:3-2-7-1-1:fffefbef-7ffffbf7-ffffffff-6fff7fff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HCC1DF840&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 1) And &H6FFF7FFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 2)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 1) And &HFFFFFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 2)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 1) And &H7FFFFBF7)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 2)
            y = p(a) Xor ((p(b) >> 1) And &HFFFEFBEF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 2)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt27
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:14-20-7-9-1:7bffc3f9-ddfff2fb-ddfbf6fb-77dfdfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HF6DAE320&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 56 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 9) And &H77DFDFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 20)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 9) And &HDDFBF6FB)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 20)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 9) And &HDDFFF2FB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 20)
            y = p(a) Xor ((p(b) >> 9) And &H7BFFC3F9)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 20)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt28
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:3-2-3-19-1:bbfffcff-f7bffcdf-e39ffffd-f7bebfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HD324A000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 19) And &HF7BEBFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 2)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 19) And &HE39FFFFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 2)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 19) And &HF7BFFCDF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 2)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 19) And &HBBFFFCFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 2)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt29
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:2-9-7-17-1:ffffffff-7fbff9df-7f6fefcf-efffffde"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HCB8F6A00&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 17) And &HEFFFFFDE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 9)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 17) And &H7F6FEFCF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 9)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 17) And &H7FBFF9DF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 9)
            y = p(a) Xor ((p(b) >> 17) And &HFFFFFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 9)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt30
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:15-12-1-1-7:fdffffff-ffffdef7-ff3fffff-f37776f7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H16537800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 60 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 1) And &HF37776F7)
            p(a + 3) = y Xor (p(d + 3) << 12)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 1) And &HFF3FFFFF)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 12)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 1) And &HFFFFDEF7)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 12)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 1) And &HFDFFFFFF)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 12)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt31
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-2281:9-11-5-6-3:e7fffba3-ffdf7fdf-efbf7fff-fd7cf7bf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HC4CBC800&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 36 : Dim c As Integer = 64
        Dim d As Integer = 68 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 6) And &HFD7CF7BF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 6) And &HEFBF7FFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 6) And &HFFDF7FDF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 6) And &HE7FFFBA3)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 72 Then b = 0
        Loop While a <> 72
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt_m

    Private Shared z as Sfmt() = { _
        New Sfmt  (1), _
        New Sfmt1 (&HFFFFFFFF&), _
        New Sfmt2 (&HFFFFFFFE&), _
        New Sfmt3 (&HFFFFFFFD&), _
        New Sfmt4 (&HFFFFFFFC&), _
        New Sfmt5 (&HFFFFFFFB&), _
        New Sfmt6 (&HFFFFFFFA&), _
        New Sfmt7 (&HFFFFFFF9&), _
        New Sfmt8 (&HFFFFFFF8&), _
        New Sfmt9 (&HFFFFFFF7&), _
        New Sfmt10(&HFFFFFFF6&), _
        New Sfmt11(&HFFFFFFF5&), _
        New Sfmt12(&HFFFFFFF4&), _
        New Sfmt13(&HFFFFFFF3&), _
        New Sfmt14(&HFFFFFFF2&), _
        New Sfmt15(&HFFFFFFF1&), _
        New Sfmt16(&HFFFFFFF0&), _
        New Sfmt17(&HFFFFFFEF&), _
        New Sfmt18(&HFFFFFFEE&), _
        New Sfmt19(&HFFFFFFED&), _
        New Sfmt20(&HFFFFFFEC&), _
        New Sfmt21(&HFFFFFFEB&), _
        New Sfmt22(&HFFFFFFEA&), _
        New Sfmt23(&HFFFFFFE9&), _
        New Sfmt24(&HFFFFFFE8&), _
        New Sfmt25(&HFFFFFFE7&), _
        New Sfmt26(&HFFFFFFE6&), _
        New Sfmt27(&HFFFFFFE5&), _
        New Sfmt28(&HFFFFFFE4&), _
        New Sfmt29(&HFFFFFFE3&), _
        New Sfmt30(&HFFFFFFE2&), _
        New Sfmt31(&HFFFFFFE1&) _
    }

    Public Shared Function IdString_m(ByVal i As Integer) As String
        Return z(i).IdString
    End Function

    Public Shared Sub InitMt_m(ByVal i As Integer,ByVal s As UInteger)
        z(i).InitMt(s)
    End Sub

    Public Shared Sub InitMtEx_m(ByVal i As Integer,ByVal k As UInteger())
        z(i).InitMtEx(k)
    End Sub

    Public Shared Function NextMt_m(ByVal i As Integer) As UInteger
        Return z(i).NextMt()
    End Function

    Public Shared Function NextInt_m(ByVal i As Integer,ByVal n As Integer) As Integer
        Return z(i).NextInt(n)
    End Function

    Public Shared Function NextBit_m(ByVal i As Integer) As Integer
        Return z(i).NextBit()
    End Function

    Public Shared Function NextByte_m(ByVal i As Integer) As Integer
        Return z(i).NextByte()
    End Function

    Public Shared Function NextUnif_m(ByVal i As Integer) As Double
        Return z(i).NextUnif()
    End Function

    Public Shared Function NextIntEx_m(ByVal i As Integer,ByVal r As Integer) As Integer
        Return z(i).NextIntEx(r)
    End Function

    Public Shared Function NextChisq_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextChisq(n)
    End Function

    Public Shared Function NextGamma_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextGamma(a)
    End Function

    Public Shared Function NextGeometric_m(ByVal i As Integer,ByVal p As Double) As Integer
        Return z(i).NextGeometric(p)
    End Function

    Public Shared Function NextTriangle_m(ByVal i As Integer) As Double
        Return z(i).NextTriangle()
    End Function

    Public Shared Function NextExp_m(ByVal i As Integer) As Double
        Return z(i).NextExp()
    End Function

    Public Shared Function NextNormal_m(ByVal i As Integer) As Double
        Return z(i).NextNormal()
    End Function

    Public Shared Sub NextUnitVect_m(ByVal i As Integer,ByRef v As Double(),ByVal n As Integer)
        z(i).NextUnitVect(v,n)
    End Sub

    Public Shared Function NextBinomial_m(ByVal i As Integer,ByVal n As Integer,ByVal p As Double) As Integer
        Return z(i).NextBinomial(n,p)
    End Function

    Public Shared Sub NextBinormal_m(ByVal i As Integer,ByVal r As Double,ByRef a As Double,ByRef b As Double)
        z(i).NextBinormal(r,a,b)
    End Sub

    Public Shared Function NextBeta_m(ByVal i As Integer,ByVal a As Double,ByVal b As Double) As Double
        Return z(i).NextBeta(a,b)
    End Function

    Public Shared Function NextPower_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextPower(n)
    End Function

    Public Shared Function NextLogistic_m(ByVal i As Integer) As Double
        Return z(i).NextLogistic()
    End Function

    Public Shared Function NextCauchy_m(ByVal i As Integer) As Double
        Return z(i).NextCauchy()
    End Function

    Public Shared Function NextPoisson_m(ByVal i As Integer,ByVal l As Double) As Integer
        Return z(i).NextPoisson(l)
    End Function

    Public Shared Function NextFDist_m(ByVal i As Integer,ByVal n1 As Double,ByVal n2 As Double) As Double
        Return z(i).NextFDist(n1,n2)
    End Function

    Public Shared Function NextTDist_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextTDist(n)
    End Function

    Public Shared Function NextWeibull_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextWeibull(a)
    End Function

End Class

