Imports System
Imports System.IO

Module MainModule
    Dim fp As StreamWriter
    Dim ini As UInteger() = {&H1234, &H5678, &H9ABC, &HDEF0}

    Function Mexp() As String
        Dim delimiter As Char() = {":","-"}
        Dim id As String() = Sfmt_m.IdString_m(0).Split(delimiter)
        return id(1)
    End Function

    Sub PutStr(ByVal s As String)
        fp.Write("{0}", s)
    End Sub

    Sub PutDbl(ByVal x As Double)
        fp.Write(" {0,11:0.0000000}", x)
    End Sub

    Sub PutInt(ByVal x As Integer)
        fp.Write(" {0,3}", x)
    End Sub

    Sub PutUsg(ByVal x As UInteger)
        fp.Write("{0,10} ", x)
    End Sub

    Sub PutBit(ByVal x As Integer)
        fp.Write("{0}", x)
    End Sub

    Sub PutLn1(ByVal s As String)
        fp.WriteLine()
        fp.Write("{0,-9}", s)
    End Sub

    Sub PutLn2(ByVal s As String)
        fp.WriteLine("{0}", s)
    End Sub

    Sub EachDist(ByVal m As Integer)
        Dim i As Integer
        Dim vec(3) As Double
        Dim x, y As Double

        For i = 1 To 10000 : Sfmt_m.NextMt_m(m) : Next i
        PutStr(Sfmt_m.IdString_m(m))
        PutLn1("Unif")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextUnif_m(m)) : Next
        PutLn1("Int")
        For i = 1 To 12 : PutInt(Sfmt_m.NextInt_m(m, 1000)) : Next
        PutLn1("IntEx")
        For i = 1 To 12 : PutInt(Sfmt_m.NextIntEx_m(m, 1000)) : Next
        PutLn1("Chisq")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextChisq_m(m, 10.0#)) : Next
        PutLn1("Gamma")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextGamma_m(m, 10.0#)) : Next
        PutLn1("Geometric")
        For i = 1 To 12 : PutInt(Sfmt_m.NextGeometric_m(m, 0.2)) : Next
        PutLn1("Triangle")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextTriangle_m(m)) : Next
        PutLn1("Exp")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextExp_m(m)) : Next
        PutLn1("Normal")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextNormal_m(m)) : Next
        PutLn1("UnitVect")
        Sfmt_m.NextUnitVect_m(m, vec, 4)
        For i = 1 To 4 : PutDbl(vec(i - 1)) : Next
        PutLn1("Binomial")
        For i = 1 To 12 : PutInt(Sfmt_m.NextBinomial_m(m, 10, 0.3)) : Next
        PutLn1("Binormal")
        For i = 1 To 4 \ 2
            Sfmt_m.NextBinormal_m(m, 0.3, x, y) : PutDbl(x) : PutDbl(y)
        Next i
        PutLn1("Beta")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextBeta_m(m, 2.0#, 3.0#)) : Next
        PutLn1("Power")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextPower_m(m, 10.0#)) : Next
        PutLn1("Logistic")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextLogistic_m(m)) : Next
        PutLn1("Cauchy")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextCauchy_m(m)) : Next
        PutLn1("FDist")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextFDist_m(m, 10.0#, 20.0#)) : Next
        PutLn1("Poisson")
        For i = 1 To 12 : PutInt(Sfmt_m.NextPoisson_m(m, 2.0#)) : Next
        PutLn1("TDist")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextTDist_m(m, 10)) : Next
        PutLn1("Weibull")
        For i = 1 To 4 : PutDbl(Sfmt_m.NextWeibull_m(m, 0.3)) : Next
        PutLn1("Bit")
        For i = 1 To 48 : PutBit(Sfmt_m.NextBit_m(m)) : Next
        PutLn1("Byte")
        For i = 1 To 12 : PutInt(Sfmt_m.NextByte_m(m)) : Next
        PutLn1("Init")
        Sfmt_m.InitMt_m(m, 1234)
        For i = 1 To 4 : PutDbl(Sfmt_m.NextUnif_m(m)) : Next
        PutLn1("InitEx")
        Sfmt_m.InitMtEx_m(m, ini)
        For i = 1 To 4 : PutDbl(Sfmt_m.NextUnif_m(m)) : Next
        PutLn2("")
    End Sub


    Sub TestDist()
        Dim fname As String = "vd" + Mexp() + ".txt"
        Dim m As Integer

        fp = new StreamWriter(fname)
        For m=0 To 31 : EachDist(m) : Next
        fp.Close()
        Console.WriteLine("'{0}'쐬܂", fname)
    End Sub

    Sub TestOut()
        Dim fname As String = "vo" + Mexp() + ".txt"
        Dim s As Sfmt = new Sfmt(1234)
        Dim i As Integer

        fp = new StreamWriter(fname)
        PutLn2(s.IdString)
        PutLn2("32 bit generated randoms")
        PutLn2("init_gen_rand__________")
        For i=1 To 1000
            PutUsg(s.NextMt())
            if i mod 5 = 0 Then PutLn2("")
        Next
        PutLn2("")

        s.InitMtEx(ini)
        PutLn2("init_by_array__________")
        For i=1 To 1000
            PutUsg(s.NextMt())
            if i mod 5 = 0 Then PutLn2("")
        Next
        fp.Close()
        Console.WriteLine("'{0}'쐬܂", fname)
    End Sub

    Sub TestSpeed()
        Dim i, j, clo, min As Integer
        Dim s As Sfmt = new Sfmt(1)

        min = 32767
        For i = 1 To 10
            clo = Environment.TickCount
            For j = 1 To 100000000 : s.NextMt() : Next
            clo = Environment.TickCount - clo
            Console.Write(" {0}", clo)
            If clo < min Then min = clo
        Next
        Console.WriteLine()
        Console.WriteLine("P̎s:{0:0.000} b", min / 1000.0)
    End Sub

    Sub Main()
        Console.WriteLine("Main()ɐ䂪n܂")
        TestDist()
        TestOut()
        TestSpeed()
    End Sub

End Module
